//"diag_mz.sc","51mz : diagnostyka pozycji magazynowych",12004,0,1.0.2,SYSTEM
//"Diagnostyka",12001,14,16
////////////////////////////
// 51mz : diagnostyka pozycji magazynowych
// diag_mz.sc
////////////////////////////

string NAZWA_PLIKU = "DIAG_MZ.TXT"

string sRaportDescription

#include "Diagnostyka - funkcje"
UsunRekord_0("MZ")

sDialogTitle += "pozycji dokumentw magazynowych"

StageAddDesc("Raport odtwarza te pozycje dokumentw magazynowych, do ktrych s")
StageAddDesc("rozliczenia w bazie PW, usuwana pozycje do ktrych brak jest jakichkolwiek")
StageAddDesc("rozlicze i ktre nie s powizane z adnym dokumentem, oraz sprawdza i")
StageAddDesc("ewentualnie koryguje wartoci oraz ilo towaru rozliczonego magazynowo.")
StageAddStage("Sprawdzenie integralnoci bazy MZ oraz IMZ")
StageAddStage("Sprawdzanie pozycji na podstawie rozlicze magazynowych")
StageAddStage("Sprawdzanie poprawnoci pozycji")
StageAddStage("Porwnanie sumy pozycji z dokumentem")
StageAddStage("Sprawdzenie dugich nazw")
ChooseStages(400)

int pw,pw2,tw,dw,dp,dk, TypPozComm

MapValue mvKomplet
mvKomplet.Type(long)
string strKomplet
long idxKomplet, super, lp, idpozkoryg
int BylaPozKompletu
Long   lValue

BaseAll mz
BaseAll mz2
BaseAll mz3
BaseAll nt
BaseAll nt2
BaseAll mg
BaseAll basTemp
BaseAll xt

int bWasFromPW,err2,bKorekta, byl=0
float ilosc,wartosc
long idhandl,lTemp,id,curr_lp,idrenum, idMGP, lTemp2
string sTemp

#include "Diagnostyka pozycji magazynowych - include"

TextOut("Podsumowanie sprawdzania poprawnoci bazy pozycji dokumentw magazynowych\n\n")

OpenBaseB(mz,"MZ")
OpenBaseB(mz2,"MZ")
OpenBaseB(mz3,"MZ")
OpenBaseB(mg,"MG")
pw=OpenBase("PW")
pw2=OpenBase("PW")
tw=OpenBase("TW")
dw=OpenBase("DW")

if StageT(1) then SprawdzIMZ()
StageSummary(1)

mz.SetKey("id")
mz2.SetKey("super")
mg.SetKey("id")
SetKey(tw,"id")
SetKey(dw,"id")
SetKey(pw,"dostawy")
SetKey(pw2,"dostawy")
SetKeySeg(pw,"typi",37)

bWasFromPW=0

PopUp(1,"Sprawdzanie pozycji na podstawie rozlicze")
err=GetKey(pw,GE)

if !StageT(2) then err=1

while !err && GetKeySeg(pw,"typi")==37
	mz.SetKeySeg("id",GetKeySeg(pw,"idmg"))
	if mz.GetKey(EQ) then
		GetRec(pw,EQ)
		SetKeySeg(tw,"id",GetField(pw,"idtw"))
		if !GetRec(tw,EQ) then
			buf = using "Brak pozycji dokumentu dla towaru '%s' ilo=%.2f warto=%.2f",GetField(tw,"kod"),GetField(pw,"ilosc"),GetField(pw,"wartosc")
			mz.Clear()
			CountPW( GetField(pw,"idmg"))
			mz.SetField("id",GetField(pw,"idmg"))
			mz.SetField("flag",0x200+0x100*(Sign(GetField(pw,"ilosc"),4)<0))
			mz.SetField("subtypi",201)
			mz.SetField("typi",0)
			mz.SetField("super",GetField(pw,"iddkmg"))
			mz.SetField("lp",GetLP(GetField(pw,"iddkmg")))
			mz.SetField("idtw",GetField(pw,"idtw"))
			mz.SetField("kod",GetField(tw,"kod"))
			mz.SetField("opis",GetField(tw,"nazwa"))
			mz.SetField("ilosc",ilosc)
			mz.SetField("iloscdorozl",ilosc)
			mz.SetField("jm",GetField(tw,"jm"))
			if Sign(ilosc,4) then mz.SetField("cena",wartosc/ilosc)
			mz.SetField("wartNetto",wartosc)
			mz.SetField("wartTowaru",wartosc)
			SetKeySeg(dw,"id",GetField(pw,"iddw"))
			if GetRec(dw,EQ) then	mz.SetField("magazyn",GetField(dw,"magazyn"))
			if mg.GetRecById(GetField(pw,"iddkmg")) then
				// odtworz tylko z rekordu PW
				if TextOutAndAsk(1,buf,". Czy odtworzy na podstawie danych z rekordu PW?") then
					mz.SetField("rejestri",64)		// wybrany arbitralnie
					InsertRecB(mz)
					bWasFromPW = 1
				else
					TextOut(sNoRepair)
				endif
			else
				// odtworz z rekordu PW i MG
				if TextOutAndAsk(2,buf,". Czy odtworzy na podstawie danych z rekordu PW oraz dokumentu magazynowego?") then
					mz.SetField("magazyn",mg.GetField("magazyn"))
					mz.SetField("idkh",mg.GetField("khid"))
					mz.SetField("data",mg.GetField("data"))
					mz.SetField("osoba",mg.GetField("osoba"))
					mz.SetField("rejestri",mg.GetField("rejestrVATi"))
					if mg.GetField("idhandl")<0 then
						mz2.SetKeySeg("super",-mg.GetField("idhandl"))
						mz2.SetKeySeg("lp",0)
						err=mz2.GetRec(GE)
						while !err && mz2.GetField("super")==-mg.GetField("idhandl")
							if mz2.GetField("idhandl")==-mz.GetField("id") then mz.SetField("idhandl",-mz2.GetField("id")) : exit
							err=mz2.GetRec(NX)
						wend
					endif
					InsertRecB(mz)
				else
					TextOut(sNoRepair)
				endif
			endif
		else
			AskOkEnd(3,(using "Brak rekordu towaru na ktry wskazuje rekord PW id=%l",GetField(pw,"id")))
		endif
	endif
	err=GetKey(pw,NX)
wend

StageSummary(2)

// sprawdz, czy s dowizane do dokumentw lub rekordw rozliczen
// oraz czy pozycje handlowe i korygowane s poprawne

int sub pom()
	TextOut(" - nie znaleziono pozycji ktra mogaby by korygowana ")
	mz.SetField("idpozkoryg",0)
	UpdateRecB(mz)
endsub

SetKey(tw,"id")
mz.SetKey("super")
mz2.SetKey("id")
mz3.SetKey("super")
dp=OpenBase("dp")
SetKey(dp,"id")
OpenBaseB(nt,"NT")
nt.SetKey("id")
dk=OpenBase("dk")
SetKey(dk,"id")
mg.SetKey("id")
OpenBaseB(xt,"XT")
xt.SetKey("id")
err=mz.GetRec(FS)
progress.Reset(mz.GetRecordCount())

if !StageT(3) then err=1

while !err

// sprawdz dokladnosc wartosci
	DiagWart("ilosc",4)
	DiagWart("wartNetto",2)
	DiagWart("wartTowaru",2)
	DiagWart("iloscwp",4)
	DiagWart("iloscdorozl",4)
	DiagWart("przychod",2)
	DiagWart("rozchod",2)
	DiagWart("wartk",2)

	SetKeySeg(tw,"id",mz.GetField("idtw"))
	if !GetRec(tw,EQ) then
		if (GetField(tw,"subtypi")==3 && !(mz.GetField("flag")&0x1000)) then
			if TextOutAndAsk(13,(using "Pozycja '%s' id=%l nie ma ustawionej flagi kompletu.",mz.GetField("kod"),mz.GetField("id")),"\nCzy naprawi?") then
				mz.SetField("flag",mz.GetField("flag")|0x1000)
				mz.SetField("typi",mz.GetField("typi")|0x01)
				UpdateRecB(mz)
			else
				TextOut(sNoRepair)
			endif	
		endif
	else
		if mz.GetField("subtypi")!=102 then TextOut(using "Brak rekordu towaru na ktry wskazuje rekord MZ id=%l\n",mz.GetField("id"))
	endif

	progress.NextOne()
	xt.SetKeySeg("id",mz.GetField("magazyn"))
if !xt.GetRec(EQ) && !(xt.GetField("flag")&0x10) then
	if mz.GetField("flag")&0x400 then
		mz2.SetKeySeg("id",-mz.GetField("idhandl"))
		if !mz2.GetRec(EQ) && (mz2.GetField("id") != mz.GetField("id")) && (-mz2.GetField("idhandl") == mz.GetField("id")) && (mz2.GetField("idtw") == mz.GetField("idtw")) then
			mg.SetKeySeg("id",mz.GetField("super"))
			if mg.GetRec(EQ) then
				mg.SetKeySeg("id",mz2.GetField("super"))
				if !mg.GetRec(EQ) then
					idMGP=mg.GetField("id")
					mg.SetKeySeg("id",-mg.GetField("idhandl"))
					if !mg.GetRec(EQ) then
						if idMGP == -mg.GetField("idhandl") then
							if TextOutAndAsk(12,(using "Pozycja '%s' id=%l odwoluje si do niepoprawnego dokumentu magazynowego.",mz.GetField("kod"),mz.GetField("id")),(using "\nCzy skojarzy z pozycj dokumentu magazynowego '%s' id=%l?", mg.GetField("kod"), mg.GetField("id"))) then
								mz.SetField("super",mg.GetField("id"))
								UpdateRecB(mz)
							else
								TextOut(sNoRepair)
							endif
						endif
					else
						TextOut(using "Pozycja '%s' id=%l odwoluje si do niepoprawnego dokumentu magazynowego.",mz.GetField("kod"),mz.GetField("id"))
					endif
				else
					TextOut(using "Pozycja '%s' id=%l odwoluje si do niepoprawnego dokumentu magazynowego.",mz.GetField("kod"),mz.GetField("id"))
				endif
			else
				if -mg.GetField("idhandl") != mz2.GetField("super") then
					idMGP=mg.GetField("id")
					mg.SetKeySeg("id",-mg.GetField("idhandl"))
					if !mg.GetRec(EQ) then
						if idMGP == -mg.GetField("idhandl") then
							if TextOutAndAsk(12,(using "Pozycja '%s' id=%l odwoluje si do niepoprawnego dokumentu magazynowego.",mz2.GetField("kod"),mz2.GetField("id")),(using "\nCzy skojarzy  z pozycj dokumentu magazynowego '%s' id=%l?", mg.GetField("kod"), mg.GetField("id"))) then
								mz2.SetField("super",mg.GetField("id"))
								UpdateRecB(mz2)
							else
								TextOut(sNoRepair)
							endif
						else
							TextOut(using "Pozycja '%s' id=%l odwoluje si do niepoprawnej pozycji dokumetu magazynowego.",mz2.GetField("kod"),mz2.GetField("id"))
						endif
					else
						TextOut(using "Pozycja '%s' id=%l odwoluje si do niepoprawnej pozycji dokumetu magazynowego.",mz.GetField("kod"),mz.GetField("id"))
					endif
				endif
			endif
		else
			mg.SetKeySeg("id",mz.GetField("super"))
			if !mg.GetRec(EQ) then
				mz2.SetKey("super")
				mz2.SetKeySeg("super",-mg.GetField("idhandl"))
				mz2.SetKeySeg("lp",0)
				err	= mz2.GetRec(GE)
				while !err &&  mz2.GetField("super") == -mg.GetField("idhandl")
					if mz2.GetField("idtw") == mz.GetField("idtw") then
						mz3.SetKeySeg("super",mz.GetField("super"))
						mz3.SetKeySeg("lp",0)
						err	= mz3.GetRec(GE)
						byl=0
						while !err &&  mz3.GetField("super") == mz.GetField("super")
							if mz3.GetField("idtw") == mz2.GetField("idtw") && mz3.GetField("id") != mz.GetField("id") then
								if mz3.GetField("id") == mz2.GetField("idhandl") then
									byl=1
								endif
								exit
							endif
							err=mz3.GetRec(NX)
						wend
						if !byl then
							if TextOutAndAsk(12,(using "Pozycja '%s' id=%l odwoluje si do niepoprawnej pozycji przesunicia magazynowego.",mz.GetField("kod"),mz.GetField("id")),(using "\nCzy skojarzy  z pozycj przesunicia magazynowego '%s' id=%l?", mz2.GetField("kod"), mz2.GetField("id"))) then
								mz.SetField("idhandl",-mz2.GetField("id"))
								UpdateRecB(mz)
								exit
							else
								TextOut(sNoRepair)
							endif
						endif
					endif
					err=mz2.GetRec(NX)
				wend
				mz2.SetKey("id")
			else
				TextOut(using "Pozycja '%s' id=%l odwoluje si do niepoprawnej pozycji przesunicia magazynowego oraz dokumetu magazynowego.",mz.GetField("kod"),mz.GetField("id"))
			endif
		endif
	else
		mg.SetKeySeg("id",mz.GetField("super"))
		if !mg.GetRec(EQ) then
			if mz.GetField("flag")&0x20 then
				if mz.GetField("idhandl")!=0 then
					mz.SetField("idhandl",0)
					UpdateRecB(mz)
				endif
			else
				if mg.GetField("idhandl")!=0 || mz.GetField("idhandl")!=0 then
					sTemp="DP"
					lTemp=mz.GetField("idhandl")
					lTemp2=mg.GetField("idhandl")
					if lTemp<0 then	sTemp="BP" : lTemp=-lTemp : lTemp2=-lTemp2
					basTemp.SetBase(sTemp)						
					if mz.GetField("idhandl")==0 || basTemp.GetRecById(lTemp) || (!basTemp.GetRecById(lTemp) && ((lTemp2 != basTemp.GetField("super")) || (mz.GetField("idtw") != basTemp.GetField("idtw")))) then
						sTemp="DK"
						lTemp=mg.GetField("idhandl")
				
						if lTemp<0 then sTemp="BD" : lTemp=-lTemp 
						basTemp.SetBase(sTemp)

						if !basTemp.GetRecById(lTemp) then
							mz2.SetKey("super")
							sTemp="DP"
							lTemp=mg.GetField("idhandl")
					
							if lTemp<0 then sTemp="BP" : lTemp=-lTemp 
							basTemp.SetBase(sTemp)
							
							basTemp.SetKey("super")
							basTemp.SetKeySeg("super",lTemp)
							basTemp.SetKeySeg("lp",0)
							err=basTemp.GetRec(GE)
							while !err && basTemp.GetField("super") == lTemp
								byl=0
								if basTemp.GetField("idtw") == mz.GetField("idtw") then
									mz2.SetKey("super")
									mz2.SetKeySeg("super",mz.GetField("super"))
									mz2.SetKeySeg("lp",0)
									err	= mz2.GetRec(GE)
									while !err &&  mz2.GetField("super") == mz.GetField("super")
										lTemp2 = mz2.GetField("idhandl")
										if lTemp2 < 0 then lTemp2=-lTemp2
										if lTemp2 == basTemp.GetField("id") then
											byl=1
											exit
										endif
										err=mz2.GetRec(NX)
									wend
									idpozkoryg = mz.GetField("idpozkoryg")
									while !byl && idpozkoryg
										mz2.SetKey("id")
										mz2.SetKeySeg("id",idpozkoryg)
										if !mz2.GetRec(EQ) then
											idpozkoryg = mz2.GetField("idpozkoryg")
											super = mz2.GetField("super")
											mz2.SetKey("super")
											mz2.SetKeySeg("super",super)
											mz2.SetKeySeg("lp",0)
											err	= mz2.GetRec(GE)
											while !err &&  mz2.GetField("super") == super
												lTemp2 = mz2.GetField("idhandl")
												if lTemp2 < 0 then lTemp2=-lTemp2
												if lTemp2 == basTemp.GetField("id") then
													byl=1
													exit
												endif
												err=mz2.GetRec(NX)
											wend
										else
											idpozkoryg = 0
										endif
									wend
									if !byl then
										if TextOutAndAsk(4,(using "Pozycja '%s' id=%l odwoluje si do niepoprawnej pozycji dokumentu handlowego.",mz.GetField("kod"),mz.GetField("id")),(using "\nCzy skojarzy  z pozycj dokumetu handlowego '%s' id=%l?", basTemp.GetField("kod"), basTemp.GetField("id"))) then
											mz.SetField("idhandl",iif(sTemp=="DP",basTemp.GetField("id"),-basTemp.GetField("id")))
											UpdateRecB(mz)
											exit
										else
											TextOut(sNoRepair)
										endif
									else
										if mz.GetField("idhandl") then
											TextOut(using "Pozycja '%s' id=%l odwoluje si do niepoprawnej pozycji dokumentu handlowego.\n",mz.GetField("kod"),mz.GetField("id"))
										endif
									endif
								endif
								err=basTemp.GetRec(NX)
							wend
							SetKey(dp,"id")
							mz2.SetKey("id")
						else
							if mg.GetField("idhandl")==0 then
								if TextOutAndAsk(4,(using "Pozycja '%s' id=%l nie powinna odwolywa si do pozycji dokumentu handlowego.",mz.GetField("kod"),mz.GetField("id")),("\nCzy naprawi?")) then
									mz.SetField("idhandl",0)
									UpdateRecB(mz)
								else
									TextOut(sNoRepair)
								endif
							else
								TextOut(using "Pozycja '%s' id=%l odwoluje si do niepoprawnej pozycji dokumentu handlowego.",mz.GetField("kod"),mz.GetField("id"))
							endif
						endif
					endif			
				endif
			endif
		else
			if mz.GetField("flag")&0x20 && mz.GetField("idhandl")!=0 then
				mz.SetField("idhandl",0)
				UpdateRecB(mz)
			endif
			TextOut(using "Pozycja '%s' id=%l odwoluje si do niepoprawnego dokumentu magazynowego.",mz.GetField("kod"),mz.GetField("id"))
		endif
	endif
endif

	// sprawdz dowizania do pozycji dok. handlowego

	if mz.GetField("idhandl") then
		sTemp="DP"
		lTemp=mz.GetField("idhandl")

		if mz.GetField("flag")&0x400 then sTemp="MZ" : lTemp=-lTemp 
		basTemp.SetBase(sTemp)

		basTemp.GetRecById(lTemp)
		if mz.GetField("flag")&0x400 then
			if basTemp.GetField("flag")&0x400 then
				if -basTemp.GetField("idhandl")!=mz.GetFIeld("id") then
					TextOut(using"Pozycje przesunicia magazynowego '%s' id=%l oraz '%s' id=%l s niepoprawnie skojarzone\n",mz.GetField("kod"),mz.GetField("id"),basTemp.GetField("kod"),basTemp.GetField("id"))
				else
					if mz.GetField("id")<basTemp.GetField("id") then
						if Sign(mz.GetField("wartnetto")+basTemp.GetField("wartnetto")) || Sign(mz.GetField("przychod")+basTemp.GetField("rozchod")) || Sign(mz.GetField("rozchod")+basTemp.GetField("przychod")) then
							TextOut(using"Nie zgadzaj si wartoci netto, przychodu lub rozchodu w pozycjach przesuni magazynowych '%s' id=%l oraz '%s' id=%l.\n",mz.GetField("kod"),mz.GetField("id"),basTemp.GetField("kod"),basTemp.GetField("id"))
						endif
						if mz.GetField("data")!=basTemp.GetField("data") then
							TextOut(using"Nie zgadzaj si daty pozycji przesuni magazynowych '%s' id=%l oraz '%s' id=%l.\n",mz.GetField("kod"),mz.GetField("id"),basTemp.GetField("kod"),basTemp.GetField("id"))
						endif
					endif
				endif
			else
				mg.GetRecById(mz.GetField("super"))
				TextOut(using "Pozycja '%s' id=%l dokumentu '%s' jest skojarzona z niewaciw pozycj.\n",mz.GetField("kod"),mz.GetField("id"),mg.GetField("kod"))
			endif
		endif
	endif

	if mz.GetField("idpozkoryg") then
		if mz.GetField("idpozkoryg")>0 then
			// pozycja korygowana w bazie MZ
			mz2.SetKey("id")
			mz2.SetKeySeg("id",mz.GetField("idpozkoryg"))
			if mz2.GetRec(EQ) then
				if TextOutAndAsk(5,(using "Pozycja '%s' id=%l odwouje si do nieistniejcej pozycji korygowanej",mz.GetField("kod"),mz.GetField("id")),sAskRepair) then
					//szukam pozycji tego towaru na dok. korygowanym
					lTemp=mz.GetField("super")
					mg.SetKeySeg("id",lTemp)
					if !mg.GetRec(EQ) then
						mg.SetKeySeg("id",mg.GetField("iddokkoryg"))
						err=mg.GetRec(EQ)
						while !err && mg.GetField("idkorekt") && mg.GetField("idkorekt")!=lTemp
							mg.SetKeySeg("id",mg.GetField("idkorekt"))
							err=mg.GetRec(EQ)
						wend
						if !err && mg.GetField("idkorekt")==lTemp then
							mz2.SetKey("super")
							mz2.SetKeySeg("super",mg.GetField("id"))
							mz2.SetKeySeg("lp",0)
							err=mz2.GetRec(GE)
							while !err && mz2.GetField("super")==mg.GetField("id")
								if mz2.GetField("idtw")==mz.GetField("idtw") then exit
								err=mz2.GetRec(NX)
							wend
							if !err && mz2.GetField("super")==mg.GetField("id") then
								mz.SetField("idpozkoryg",mz2.GetField("id"))
								UpdateRecB(mz)
							else
								pom()
							endif
							mz2.SetKey("id")
						else
							pom()
						endif
					else
						TextOut(" - BRAK DOKUMENTU POZYCJI - uruchom raport diagnostyczny dla bazy MG  ")
						pom()
					endif
				else
					TextOut(sNoRepair)
				endif
			else
				if mz.GetField("lp")!=mz2.GetField("lp") then
					TextOut(using "Pozycja '%s' id=%l odwouje si do pozycji korygowanej o innej lp\n",mz.GetField("kod"),mz.GetField("id"))
				endif
			endif
		else
			// pozycja korygowana w bazie DP
			SetKeySeg(dp,"id",-mz.GetField("idpozkoryg"))
			if GetKey(dp,EQ) then
				if TextOutAndAsk(6,(using "Pozycja '%s' id=%l odwouje si do nieistniejcej pozycji korygowanej",mz.GetField("kod"),mz.GetField("id")),sAskRepair) then
					mg.SetKeySeg("id",mz.GetField("super"))
					if !mg.GetRec(EQ) then
						SetKeySeg(dk,"id",-mg.GetField("iddokkoryg"))
						if !GetRec(dk,EQ) then
							SetKey(dp,"super")
							SetKeySeg(dp,"super",GetField(dk,"id"))
							SetKeySeg(dp,"lp",0)
							err=GetRec(dp,GE)
							while !err && GetField(dp,"super")==GetField(dk,"id")
								if GetField(dp,"idtw")==mz.GetField("idtw") then exit
								err=GetRec(dp,NX)
							wend
							if !err && GetField(dp,"super")==GetField(dk,"id") then
								mz.SetField("idpozkoryg",-GetField(dp,"id"))
								UpdateRecB(mz)
							else
								pom()
							endif
							SetKey(dp,"id")
						else
							pom()
						endif
					else
						TextOut(" - BRAK DOKUMENTU POZYCJI - uruchom raport diagnostyczny dla bazy MG  ")
						pom()
					endif
				else
					TextOut(sNoRepair)
				endif
			endif
		endif
	endif

	mg.SetKeySeg("id",mz.GetField("super"))
	SetKeySeg(pw,"typi",37)
	SetKeySeg(pw,"idmg",mz.GetField("id"))
	SetKeySeg(pw,"iddw",0)
	if mg.GetKey(EQ) then
		if GetKey(pw,GE) || GetField(pw,"typi")!=37 || GetField(pw,"idmg")!=mz.GetField("id") then
			Clear(tw)
			SetKeySeg(tw,"id",mz.GetField("idtw"))
			GetRec(tw,EQ)
			if TextOutAndAsk(7,(using "Znaleziono pozycje '%s' id=%l ktra nie jest powizana z adnym dokumentem ani rozliczeniem",GetField(tw,"kod"),mz.GetField("id")),". Czy usun?") then
				id=mz.GetField("idlongname")
				if !DeleteRecB(mz) && id then	// usun notatke
					nt.SetKeySeg("id",id)
					if !nt.GetRec(EQ) then nt.Delete()
				endif
			else
				TextOut(" - NIE USUNITO\n")
			endif
		endif
	endif
	if Sign(mz.GetField("wartNetto")-(mz.GetField("przychod")+mz.GetField("rozchod")),2) then
		buf=""
		if !mg.GetRecById(mz.GetField("super")) then buf=mg.GetField("kod")
		TextOut(using "Nie zgadza si suma wartoci przychodu i rozchodu z wartoci netto w pozycji '%s' id=%l dokumentu '%s'\n",mz.GetField("kod"),mz.GetField("id"),buf)
	endif
	if Sign(mz.GetField("wartNetto") - mz.GetField("wartTowaru"),2) then
		buf=""
		if !mg.GetRecById(mz.GetField("super")) then buf=mg.GetField("kod")

		if TextOutAndAsk(15,(using "Nie zgadza si wartTowaru z wartoci netto w pozycji '%s' id=%l dokumentu '%s'.",mz.GetField("kod"),mz.GetField("id"),buf),"\nCzy przebi na warto netto?") then
			mz.SetField("wartTowaru", mz.GetField("wartNetto"))
			UpdateRecB(mz)
		else
			TextOut(" - NIE NAPRAWIONO\n")
		endif
	endif

	err=mz.GetRec(NX)
wend

StageSummary(3)

// czy suma wartNetto z pozycji rwna si wartoci na dokumencie
PopUp(1,"Sprawdzanie pozycji dokumentu:")

mg.SetKey("id")
mz.SetKey("super")
err=mg.GetRec(FS)

progress.Reset(mg.GetRecordCount())

if !StageT(4) then err=1
int tbs,flag_test
while !err
	progress.NextOne()
	if mg.GetField("typi")==201 && mg.GetField("subtypi")!=0 && mg.GetField("subtypi")!=2 then

		// naliczenie wartoci netto 

		PopUp(2,mg.GetField("kod"))
		id=mg.GetKeySeg("id")
		mz.SetKey("super")
		mz.SetKeySeg("super",id)
		mz.SetKeySeg("lp",-32768)
		wartosc=0
		err=mz.GetRec(GE)
		bKorekta = !!mg.GetField("iddokkoryg")
		curr_lp = 0
		idrenum=0
		TypPozComm = -1
		mvKomplet.Clear()
		idxKomplet = 0
		BylaPozKompletu = 0
		byl=0
		while !err && mz.GetKeySeg("super")==id
			if (mz.GetField("flag")&0x2000) then
				if TextOutAndAsk3(14,(using "Pozycja '%s' dokumentu '%s' zaznaczona jest jako anulowana, podczas gdy dokument nie jest anulowany",mz.GetField("kod"),mg.GetField("kod"))) then
					mz.SetField("flag",mz.GetField("flag")^0x2000)
					UpdateRecB(mz)
				else
					TextOut(sNoRepair)
				endif	
			endif
			if (mz.GetField("lp")<=0) || (!(mz.GetField("flag")&0x4000) && !(mz.GetField("flag")&0x1000) && mz.GetField("lp")-curr_lp != 1 && !bKorekta) then
			//sprawdz pozycje ktora nie jest kompletem ani pozycja kompletu
				idrenum = mg.GetField("id")
			else
				if (mz.GetField("flag")&0x1000) then
				//sprawdz pozycje typu komplet
					if byl!=3 then
					//jesli nie byla jeszcze sprawdzona
						if byl!=2 then					
						//jesli poprzednio byla pozycje ktora nie jest pozycja kompletu
							if  (mz.GetField("lp")-curr_lp != 1 && !bKorekta) then idrenum = mg.GetField("id")
						else
						//poprzednio byla pozycja kompletu ale jest to bezposrednio kolejny komplet
							// jesli poprzednia nie nalezy do tego kompletu
							if (mz.GetField("lp")-curr_lp)==1 then byl = 1
							// jesli poprzednia nalezala do tego kompletu
							if (mz.GetField("lp")-curr_lp)==0 then byl = 2
							// jelsi numeracja calkiem rozna
							if (mz.GetField("lp")-curr_lp > 1 && !bKorekta) then idrenum = mg.GetField("id")								
						endif
					endif
				else
					if (mz.GetField("flag")&0x4000) && !byl then
						if (mz.GetField("lp")-curr_lp != 1 && !bKorekta) then idrenum = mg.GetField("id")
						super=mz.GetField("super")
						lp=mz.GetField("lp")
						if !mz.GetRec(NX) then
							if mz.GetField("super")!=super || mz.GetField("lp")!=lp || !(mz.GetField("flag")&0x1000) then
								idrenum = mg.GetField("id")
							else
								byl = 3
							endif
							mz.GetRec(PR)
						endif
					else
						if byl==1 then
							if ((mz.GetField("lp")-curr_lp-tbs) && !bKorekta) then idrenum = mg.GetField("id")
							byl=2
						else
							if (mz.GetField("lp")-curr_lp != 1 && !bKorekta) then idrenum = mg.GetField("id")
							byl=2
						endif
					endif						
				endif
			endif

			if !(mz.GetField("flag")&0x4000) && byl!=3 then byl = 0
			if (mz.GetField("flag")&0x1000) && byl!=3 then byl = 1

			curr_lp=mz.GetField("lp")

			if !(mz.GetField("flag")&0x2000) then
				if (mz.GetField("flag")&0x1000) || (mz.GetField("flag")&0x4000) then
					if (mz.GetField("flag")&0x1000) then
						TypPozComm =  mz.GetField("typi")&0x01
						if TypPozComm then
							idxKomplet=1
							strKomplet = using "%d",(mvKomplet.Size()+1)
							mvKomplet.Set(strKomplet,mz.GetField("id"))
						endif
					else
						super=mz.GetField("super")
						lp=mz.GetField("lp")
						if !mz.GetRec(NX) then
							if mz.GetField("super")==super && mz.GetField("lp")==lp && (mz.GetField("flag")&0x1000) then
								TypPozComm =  mz.GetField("typi")&0x01
								BylaPozKompletu = 1
							endif
							mz.GetRec(PR)
						endif
					endif
					if idxKomplet && ((mz.GetField("flag")&0x4000) || BylaPozKompletu) then
						idxKomplet=0
						BylaPozKompletu=0
						mvKomplet.Del(mvKomplet.GetKey(mvKomplet.Size()))
					endif
					if (mz.GetField("flag")&0x4000) && (!(mz.GetField("typi")&0x01) != TypPozComm) then
						if mz.GetField("typi")&0x01 then
							mz.SetField("typi",mz.GetField("typi")^0x01)
						else
							mz.SetField("typi",mz.GetField("typi")|0x01)
						endif
						UpdateRecB(mz)
					endif
				else
					if mz.GetField("typi")&0x01 then
						mz.SetField("typi",mz.GetField("typi")^0x01)
						UpdateRecB(mz)
					endif
					idxKomplet = 0
					BylaPozKompletu = 0
					TypPozComm = -1
				endif
			else
				idxKomplet = 0
				BylaPozKompletu = 0
				TypPozComm = -1
				if !(mz.GetField("typi")&0x01) then
					mz.SetField("typi",mz.GetField("typi")|0x01)
					UpdateRecB(mz)
				endif
			endif

			if !(mz.GetField("typi") & 0x01) then wartosc+=mz.GetField("wartNetto")		// 1=komplet lub anulowana

			if mz.GetField("magazyn")!=mg.GetField("magazyn") then
				if TextOutAndAsk3(13,(using "Nie zgadza si magazyn pozycji '%s' dokumentu '%s'",mz.GetField("kod"),mg.GetField("kod"))) then
					mz.SetField("magazyn",mg.GetField("magazyn"))
					UpdateRecB(mz)
				else
					TextOut(sNoRepair)
				endif
			endif

			if mz.GetField("data")!= mg.GetField("data") then
				mz.SetField("data",mg.GetField("data"))
				if mz.Update() then
					TextOut(using "Nie zgadza si data na pozycji '%s' dokumentu '%s' - NIE NAPRAWIONO - bd zapisu do bazy MZ\n",mz.GetField("kod"),mg.GetField("kod"))
				else
					TextOut(using "Nie zgadza si data na pozycji '%s' dokumentu '%s' - NAPRAWIONO\n",mz.GetField("kod"),mg.GetField("kod"))
				endif
			endif

			if mz.GetField("idkh")!= mg.GetField("khid") then
				mz.SetField("idkh",mg.GetField("khid"))
				if mz.Update() then
					TextOut(using "Nie zgadza si kontrahent na pozycji '%s' dokumentu '%s' - NIE NAPRAWIONO - bd zapisu do bazy MZ\n",mz.GetField("kod"),mg.GetField("kod"))
				else
					TextOut(using "Nie zgadza si kontrahent na pozycji '%s' dokumentu '%s' - NAPRAWIONO\n",mz.GetField("kod"),mg.GetField("kod"))
				endif
			endif

			flag_test=mz.GetField("flag")&0x4000
			err=mz.GetRec(NX)
			
			//testowanie sytuacji gdy w bazie mz ustawionej wedug segmentu klucza "lp" 
			//pierwszy element kompletu moe by wczeniej wczytany ni dany komplet
			//gdy maj takie samo lp 
			if !tbs then
				tbs=(mz.GetField("lp")==curr_lp) && (mz.GetField("flag")&0x1000) && mz.GetField("super")==super
			else			
				if(flag_test==(mz.GetField("flag")&0x4000)) then tbs=0
			endif
		wend
		if idrenum then
			// zapamietaj liczbe bledow weryfikacji przed migracja (ponizsze pytanie ja zwieksza)
			If EnabledVMarker() Then lValue = VError
			if TextOutAndAsk(8,(using "Pozycje dokumentu '%s' maj nieuporzdkowane numery",mg.GetField("kod")),". Czy uporzdkowa numery pozycji dokumentu") then
				Przenumeruj(idrenum)
			else
				If EnabledVMarker() Then
					// weryfikacja przed migracja - naprawiamy
					Przenumeruj(idrenum)
				Else
					TextOut(sNoRepair)
				EndIf
			endif
			// odtworz liczbe bledow weryfikacji przed migracja
			If EnabledVMarker() Then VError = lValue
		else
			while mvKomplet.Size()
				mz.GetRecById(mvKomplet.Get(mvKomplet.Size()))
				mz.SetField("typi",mz.GetField("typi")^0x01)
				UpdateRecB(mz)
				wartosc+=mz.GetField("wartNetto")
				mvKomplet.Del(mvKomplet.GetKey(mvKomplet.Size()))
			wend
		endif

		if Sign(mg.GetField("netto")-wartosc,2) then TextOut(using "Nie zgadza si warto NETTO w dokumencie '%s'\n",mg.GetField("kod"))

	endif

	err=mg.GetRec(NX)
wend

StageSummary(4)

PopUp(1,"Sprawdzanie dugich nazw")
PopUp(2,"")

if StageT(5) then

OpenBaseB(nt2,"NT")
mz.SetKey("id")
nt.SetKey("id")
nt2.SetKey("super")
nt2.SetKeySeg("typi",16)
nt2.SetKeySeg("baza",37)
err=mz.GetRec(FS)
progress.Reset(mz.GetRecordCount())
while !err
	progress.NextOne()
  if mz.GetField("idlongname") then
		nt.SetKeySeg("id",mz.GetField("idlongname"))
    if nt.GetRec(EQ) || nt.GetField("typi")!=16 || nt.GetField("baza")!= 37 || nt.GetFIeld("super")!=mz.GetField("id") then
			nt2.SetKeySeg("super",mz.GetField("id"))
			id = 0
			if !nt2.GetRec(EQ) then id=nt2.GetField("id")
      if TextOutAndAsk3(9,(using "Pozycja '%s' id=%l ma niewaciwie powizan dug nazw",mz.GetField("kod"),mz.GetField("id"))) then
	 	    mz.SetField("idlongname",id)
  	 	  UpdateRecB(mz)
			else
				TextOut(sNoRepair)
			endif
		endif
  endif
	
	err=mz.GetRec(NX)
wend

nt.SetKey("super")
nt.SetKeySeg("typi",16)
nt.SetKeySeg("baza",37)
mz.SetKey("id")
err=nt.GetRec(GE)
while !err && nt.GetField("typi")==16 && nt.GetField("baza")==37
	mz.SetKeySeg("id",nt.GetField("super"))
	if mz.GetRec(EQ) then
		if TextOutAndAsk3(10,(using "W bazie notatek znajduje si rekord o numerze %l odwoujcy si do nieistniejcej pozycji",nt.GetField("id"))) then
			DeleteRecB(nt)
		else
			TextOut(sNoRepair)
		endif
	else
		if mz.GetField("idlongname")!=nt.GetField("id") then
      if TextOutAndAsk3(11,(using "Pozycja '%s' id=%l ma niewaciwie powizan dug nazw",mz.GetField("kod"),mz.GetField("id"))) then
	 	    mz.SetField("idlongname",nt.GetField("id"))
  	 	  UpdateRecB(mz)
			else
				TextOut(sNoRepair)
			endif
		endif
	endif
	err=nt.GetRec(NX)
wend

StageSummary(5)

endif // stage

if bWasFromPw then TextOut("\n\nUruchom raport diagnostyczny dla bazy dokumentw magazynowych gdy utworzono pozycje nie dowizane do dokumentw.\n ")
ShowFileInfo()
close

buf = IIF( GetVError() == 0 , "" , "errorDiagMZ" )