//"Mig_SQL.sc","Weryfikacja przed migracj",12004,0,1.0.3,SYSTEM
//"Diagnostyka",12001,14,16
////////////////////////////
// Weryfikacja przed migracj
// Mig_SQL.sc
////////////////////////////

int errors = 0
int warnings = 0
int unapproved = 0
Int corruptDate = 0
int userbreak = 0
int fromarchive = 0
int errorDiagMG = 0  //bdy w diag MG blokujce migracj pen
int errorDiagMZ = 0  //bdy w diag MZ blokujce migracj pen
int errorDiagPW = 0  //bdy w diag PW blokujce migracj pen
int errorDiagDW = 0  //bdy w diag DW blokujce migracj pen
int errorDiagSM = 0  //bdy w diag SM blokujce migracj pen
int stopMigDiagDW = 0  //bdy w diag DW blokujce kad migracj
int pos

string par_arg0 = ""
string par_arg1 = ""
string par_arg2 = ""
string par_arg3 = ""
string par_arg4 = ""

int pdfGen = 0
string pdfPath = ""
string errorDiag = ""
string cancelWer = ""
string migrationInfoText = "MOLIWE BD DO WYBORU DWIE OPCJE MIGRACJI:\n1.Migracja czciowa: tylko dokumenty patnoci i stany magazynowe\n2.Migracja standardowa: dokumenty handlowe, zamwienia, patnoci, stany magazynowe BEZ dokumentw magazynowych.\n"
int runrap = 0

// Uruchomiony z menu "Weryfikacja bazy przed migracj"
// arg4 - gdy tryb zapisu do PDF przekazywany katalog
runrap = 1
par_arg1 = "1"
par_arg2 = "1"

// nazwa katalogu dla generowanych plikw PDF
if len(arg4) > 0 then
	pdfGen = 1
	pdfPath = arg4
	par_arg3 = "1"
endif

// Uruchomiony z menu "Weryfikacja bazy przed migracj"
// arg5 - gdy chcemy przrwa weryfikacj przy bedach w diag magazynowych i dok w buforze 
if len(arg5) > 0 then
	cancelWer = arg5
	par_arg4 = "1"
endif

Int    logEnable = 1
Int    typWydruku = 0
Int    wide = 0
String nazwaRaportu
String nazwaRaportu2
Date   DataSystemowa
Int    bFirst = 1
Int    logDefaultHandle

#include "Weryfikacja przed migracj - include"
#include "Diagnostyka - funkcje"

SetStrona( 1900, 1900, 2300)
strona 70, 250, 70, 100
setFont( copyFont( "tekst", -1, 30 ) )
nazwaRaportu = "Test bazy przed migracj danych do SQL"
nazwaRaportu += " - SPRAWDZENIE"

string sVer = prgVersionSelf()
if sVer then nazwaRaportu2 = "Wersja " + sVer

record DiagReport
	string diag_file[256]
	string diag_name[256] 
endrec

// inicjujemy maksimum liczby raportow diagnostycznych HM i FA
int DIAG_COUNT = 30

record DiagnostykaReports
	DiagReport reports(DIAG_COUNT)

	int sub AddReport(int pos, string diag_file, string diag_name)
		reports(pos).diag_file = diag_file
		reports(pos).diag_name = diag_name
	endsub

	int sub InitReports()
#include "Weryfikacja przed migracj - raporty"
	endsub

	string sub DiagFile(int pos)
		DiagFile = reports(pos).diag_file
	endsub

	string sub DiagName(int pos)
		DiagName = reports(pos).diag_name
	endsub

endrec

DiagnostykaReports reports
reports.InitReports()

int sub Opis( int pie)
endsub

int sub Podsumowanie( int last)
endsub

Header(1)

int sub RunSingleReport(int pos)
	string retvalue 
	string diag_name = reports.DiagName(pos)

	// sub, kolejnych raportw nie wykonujemy po przerwaniu ktregokolwiek
	if userbreak != 0 then exit 
	
	if (cancelWer != "") then
		//przerwanie migracji penej
		if (unapproved != 0 || corruptDate != 0 || errorDiagMG != 0 || errorDiagMZ != 0 || errorDiagPW != 0 || errorDiagDW != 0 || errorDiagSM != 0 || stopMigDiagDW!=0) then exit
	endif

	if pdfGen then
		retvalue = Run( diag_name, -2, pdfPath, par_arg0, par_arg1, par_arg2, par_arg3, pdfPath, GetVMarker() )
	else
		retvalue = Run( diag_name, par_arg0, par_arg1, par_arg2, par_arg3, "", "", GetVMarker() )
	endif

	if mid( retvalue, 1, 2 ) == "0:" then
		close
		error using "Niepoprawnie wykonany raport: \"%s\" (%s)", diag_name, reports.DiagFile(pos)
	endif

	string sStatus 
	if mid( retvalue, 1, 2 ) == "1:" then
		userbreak = 1
	else
		print using "Wykonanie raportu \"%s\".\n", diag_name
		if mid( retvalue, 3, 10 ) == "unapproved" then
			unapproved = 1
			sStatus = "false"
		else
			If Mid( retvalue, 3, 11 ) == "corruptDate" Then
				corruptDate = 1
				sStatus = "false"
			Else
				if mid( retvalue, 3, 6 ) == "errors" then
					errors = 1
					sStatus = "false"
				else
					if mid( retvalue, 3, 11 ) == "errorDiagMG" then
						errorDiagMG = 1
					endif
					if mid( retvalue, 3, 11 ) == "errorDiagMZ" then
						errorDiagMZ = 1
					endif
					if mid( retvalue, 3, 11 ) == "errorDiagPW" then
						errorDiagPW = 1
					endif
					if mid( retvalue, 3, 11 ) == "errorDiagDW" then
						errorDiagDW = 1
					endif
					if mid( retvalue, 3, 11 ) == "errorDiagSM" then
						errorDiagSM = 1
					endif
					if mid( retvalue, 3, 13 ) == "stopMigDiagDW" then
						stopMigDiagDW = 1
					endif
					if mid( retvalue, 3, 8 ) == "warnings" then
						warnings = 1
					else
						if mid( retvalue, 3, 11 ) == "fromArchive" then
							fromarchive = 1
						else			
						endif
					endif
					sStatus = "true"
				endif
			EndIf
		endif
	endif

endsub

rexParser rp
rp.init( " " )
int rpc = rp.parse( getResourceString( "AboutComponent" ) )

for pos = 1 to pos > DIAG_COUNT
	RunSingleReport(pos)
next pos

buf = ""

if userbreak != 0 then 
	print "\nUWAGA: Weryfikacja zostaa przerwana.\n"
	buf = "errors"
endif

if buf == "" && ( unapproved != 0 || corruptDate != 0 || errors != 0 || errorDiagMG != 0 || errorDiagMZ != 0 || errorDiagPW != 0 || errorDiagDW != 0 || errorDiagSM != 0 || stopMigDiagDW != 0) then
	if unapproved != 0 then
		print "\nUWAGA:\nW bazie danych znaleziono dokumenty w buforze.\nPrzed wykonaniem migracji naley je usun.\n"
		buf = "unapproved"
	endif

	if stopMigDiagDW != 0 then
		buf = "stopMigDiagDW"
	endif

	If corruptDate != 0 Then
		Print "\nUWAGA:\nDiagnostyka bazy przed migracj znalaza dokumenty z datami pniejszymi ni " + sVerifyMaxDate + ".\nPrzed wykonaniem migracji naley poprawi bdne daty w dokumentach.\n"
		If buf == "" Then 
			buf = "corruptDate" 
		else 
			if buf = "unapproved" then
				buf = "unapprovedAndcorruptDate" 
			endif
		endif
	EndIf

	if errors != 0 then
		print "\nUWAGA:\nDiagnostyka bazy przed migracj wykazaa bdy.\nPrzed wykonaniem migracji baza wymaga naprawy.\n"
		if buf == "" then buf = "errors"
	endif

	if errorDiagMG != 0 then 
		errorDiag = "MG" 
		if buf == "" then buf = "errorDiagMG"
	endif
	if errorDiagMZ != 0 then 
	   if Len(errorDiag) > 0 then
			errorDiag += ", MZ"
		else
			errorDiag = "MZ"
		endif
		if buf == "" then buf = "errorDiagMZ"
	endif
	if errorDiagPW != 0 then
		if Len(errorDiag) > 0 then
			errorDiag += ", PW"
		else
			errorDiag = "PW"
		endif
		if buf == "" then buf = "errorDiagPW"
	endif
	if errorDiagDW != 0 then 
		if Len(errorDiag) > 0 then
			errorDiag += ", DW"
		else
			errorDiag = "DW"
		endif 
		if buf == "" then buf = "errorDiagDW"
	endif
	if errorDiagSM != 0 then 
		if Len(errorDiag) > 0 then
			errorDiag += ", SM"
		else
			errorDiag = "SM"
		endif 
		if buf == "" then buf = "errorDiagSM"
	endif

	//informacje wyswietlane na raporcie
	if ((Len(errorDiag) == 0) || (buf == "unapproved") || (buf == "corruptDate") || (buf == "errors")) && (buf != "stopMigDiagDW") then
		print "\nUWAGA:\nDiagnostyka bazy przed migracj wykazaa bdy."
	else
		if Len(errorDiag) == 2 && (buf != "stopMigDiagDW") then
			print using "\nUWAGA:\nDiagnostyka bazy przed migracj wykazaa bdy dla tabeli %s.\n\n %s", errorDiag, migrationInfoText
		else 
			if (buf != "stopMigDiagDW") then
				print using "\nUWAGA:\nDiagnostyka bazy przed migracj wykazaa bdy dla tabel %s.\n\n %s", errorDiag, migrationInfoText
			endif
		endif
    endif

	if (buf == "stopMigDiagDW") then
		print "\nUWAGA:\nDiagnostyka bazy przed migracj wykazaa bdne iloci dostaw w tabeli DW. Naley naprawi baz przed wykonaniem migracji."
	endif

	If buf == "" Then buf = "errorDiag"
	if pdfGen != 0 then print using "Szczegowe informacje weryfikacji przed migracj zapisano w katalogu:\n%s\n", pdfPath

	//informacje wyswietlane w oknie
	if (Len(errorDiag) == 0 || (buf == "unapproved") || (buf == "corruptDate") || (buf == "errors")) && (buf != "stopMigDiagDW") then
		message "Diagnostyka bazy przed migracj wykazaa bdy."
	else
		if buf == "unapprovedAndcorruptDate" then
			if Len(errorDiag) == 2 then
				message using "W bazie danych znaleziono dokumenty w buforze oraz dokumenty z bdnymi datami.\nPrzed wykonaniem migracji naley je usun z bufora oraz poprawi daty na dokumentach.\nDiagnostyka bazy przed migracj wykazaa bdy dla tabeli %s.\n\n %s Przed wykonaniem migracji naley wykona operacje wskazane w podsumowaniu zbiorczego raportu.", errorDiag, migrationInfoText
			else
				message using "W bazie danych znaleziono dokumenty w buforze oraz dokumenty z bdnymi datami.\nPrzed wykonaniem migracji naley je usun z bufora oraz poprawi daty na dokumentach.\nDiagnostyka bazy przed migracj wykazaa bdy dla tabel %s.\n\n %s Przed wykonaniem migracji naley wykona operacje wskazane w podsumowaniu zbiorczego raportu.", errorDiag, migrationInfoText	
			endif	
		else
			if buf == "unapproved" then
				if Len(errorDiag) == 2 then
					message using "W bazie danych znaleziono dokumenty w buforze.\nPrzed wykonaniem migracji naley je usun z bufora.\nDiagnostyka bazy przed migracj wykazaa bdy dla tabeli %s.\n\n %s Przed wykonaniem migracji naley wykona operacje wskazane w podsumowaniu zbiorczego raportu.", errorDiag, migrationInfoText
				else
					message using "W bazie danych znaleziono dokumenty w buforze.\nPrzed wykonaniem migracji naley je usun z bufora.\nDiagnostyka bazy przed migracj wykazaa bdy dla tabel %s.\n\n %s Przed wykonaniem migracji naley wykona operacje wskazane w podsumowaniu zbiorczego raportu.", errorDiag, migrationInfoText
				endif
			else 
				If buf == "corruptDate" Then
					if Len(errorDiag) == 2 then
						message using "Diagnostyka bazy przed migracj znalaza dokumenty z datami pniejszymi ni " + sVerifyMaxDate + ".\nPrzed wykonaniem migracji naley poprawi bdne daty w dokumentach.\nDiagnostyka bazy przed migracj wykazaa bdy dla tabeli %s.\n\n %s Przed wykonaniem migracji naley wykona operacje wskazane w podsumowaniu zbiorczego raportu.", errorDiag, migrationInfoText
					else
						message using "Diagnostyka bazy przed migracj znalaza dokumenty z datami pniejszymi ni " + sVerifyMaxDate + ".\nPrzed wykonaniem migracji naley poprawi bdne daty w dokumentach.\nDiagnostyka bazy przed migracj wykazaa bdy dla tabel %s.\n\n %s Przed wykonaniem migracji naley wykona operacje wskazane w podsumowaniu zbiorczego raportu.", errorDiag, migrationInfoText
					endif
				else
					If buf == "stopMigDiagDW" Then
						message "Diagnostyka tabeli DW wykazaa bdy wymagajce naprawy. Migracja nie jest moliwa."
					endif
				endif
			endif	
		endif
	endif
endif

if buf == "" && fromarchive != 0 then
	print "\nUWAGA:\nW bazie danych znaleziono dokumenty zaimportowane z archiwum.\nMoliwa tylko migracja dokumentw pieninych i stanw magazynowych.\n"
	buf = "fromarchive"
	if pdfGen != 0 then print using "Szczegowe informacje weryfikacji przed migracj zapisano w katalogu:\n%s\n", pdfPath
	message "W bazie danych znaleziono dokumenty zaimportowane z archiwum.\nMoliwa tylko migracja dokumentw pieninych i stanw magazynowych."
endif

if buf == "" then
	if warnings == 1 then
		message "Nie wykryto bdw blokujcych migracj."
		buf = "warnings"
	else
		message "Nie wykryto bdw."
	endif
endif

if cancelWer != "" && buf != "" then
	buf = "unverified"
endif

Footer(1)

close
