//"diag_mg.sc","51mg : diagnostyka dokumentw magazynowych",12004,0,1.0.1,SYSTEM
//"Diagnostyka",12001,14,16
////////////////////////////
// 51mg : diagnostyka dokumentw magazynowych
// diag_mg.sc
////////////////////////////
// Napisa: Sebastian Nowak
// data:    98.09.08

int i=1, znacznik, imsg=1, imsg2=1
string RodzDok(1), sTypDk, msg(1), msg2(1)

string NAZWA_PLIKU = "DIAG_MG.TXT"

string sRaportDescription

#include "Diagnostyka - funkcje"

UsunRekord_0("MG")

sDialogTitle += "dokumentw magazynowych"

#define DOK_DIAG "DIAG"

StageAddDesc("Raport sprawdza katalogi oraz rodzaje dokumentw, odtwarza dokumenty na")
StageAddDesc("podstawie pozycji dokumentw oraz sprawdza zgodno wartoci dokumentu")
StageAddDesc("z sum wartoci pozycji.")
StageAddStage("Porwnanie z baz wzorcow")
StageAddStage("Sprawdzenie integralnoci bazy MG oraz IMG")
StageAddStage("Sprawdzenie rodzajw oraz katalogw")
StageAddStage("Sprawdzanie dokumentw na podstawie pozycji dokumentw")
StageAddStage("Sprawdzanie wartoci w dokumentach")
StageAddStage("Sprawdzanie rozlicze magazynowych")
ChooseStages(400)

int kh, mz, mz2
BaseAll mg
BaseAll mg2
BaseAll mg3
BaseAll xt
BaseAll zz
BaseAll basTemp
int pw2
pw2=OpenBase("PW")
int stGw,bylyGw,iTemp, odpowiedz(1)
long lTemp, idmg
long wszystkie, wKoszu
string sBezNapr,sErrNapr, sErrXtNapr, sTemp
sErrXtNapr = "Bd zapisu do bazy XT"
float netto,fPrzychod,fRozchod, iloscPW, wartoscPW

int bezKontr,brakPN
long super,nextDiagDok,super2
long korygowaneBrak(1), rooty(1)
long iloscKorBr

sErrNapr=" :  NIE NAPRAWIONO - bd wstawiania nowego rekordu\n"
stGw = CopyFont ( "tytu", 1, 50 )

// ************* funkcje **
int sub ZapiszGwiazdki()
	int temp
	bylyGw=1
	temp=SetFont(stGw)
	TextOut(" *** ")
	SetFont(temp)
endsub

int sub SprawdzTypyDok(long sup)
	int err
  BaseXT lxt

	lxt.Open()

	lxt.SetKey("super")
	lxt.SetKeySeg("super",sup)
	err=lxt.GetRec(GE)

	while !err && lxt.GetKeySeg("super")==sup
		if lxt.GetField("subtypi")==26 then
			SprawdzTypyDok(lxt.GetField("id"))
		else
			RodzDok(i)=lxt.GetField("kod")
			grow RodzDok, 1
			i+=1
		endif
		err=lxt.GetRec(NX)
	wend

	lxt.Close()

endsub

int sub SprawdzWzorcowa()
	int wzor = OpenBaseWzor("MG")
	SetKey(wzor,"id")
	err=GetRec(wzor,FS)
	while !err
		if mg.GetRecById(GetField(wzor,"id")) then
			if TextOutAndAsk3(53,(using "We wzorcowej bazie dokumentw magazynowych istnieje rekord, ktrego nie ma w bazie firmy id=%l kod='%s'",GetField(wzor,"id"),GetField(wzor,"kod"))) then
				mg.CopyFieldsFrom(wzor)
				InsertRecB(mg)
			else
				TextOut(sNoRepair)
			endif			
		endif
		err=GetREc(wzor,NX)
	wend
	close wzor
endsub

#include "Sprawd baz dokumentw magazynowych - include"

int sub SprawdzDokumenty()

	int podkatalog
	long temp
	xt.SetKey("id")
	xt.SetKeySeg("id", 2500)
	if xt.GetRec(EQ) then error "Brak roota katalogu"
	PopUp(1,(using "Sprawdzanie dokumentw magazynowych\n"))
	WriteStatusBar(using "Sprawdzanie dokumentw magazynowych")

	PopUp(2,"Sprawdzanie katalogw")
	wszystkie=wKoszu=0
	if SprawdzKatalog(xt) then
		if xt.Update() then
			TextOut(using "NIE NAPRAWIONO - %s\n", sErrXtNapr)
			exit
		endif
	endif
	
	PopUp(2,"Sprawdzanie rodzajw")

	ZliczRodzaje(0)		// 0 - bez sprawdzania istnienia rekordu w bazie MG

	// zapisanie wartoci wszystkich oraz w koszu
	if xt.GetRecById(4500) then error "Brak rekordu w bazie XT"
	if xt.GetField("zawartosc")!=wszystkie then
		TextOut("Poprawiono ilo wszystkich dokumentw\n")
		xt.SetField("zawartosc",wszystkie)
		if xt.Update() then error sErrXtNapr
	endif

	if firma.code != "HL" then
		if xt.GetRecById(4599) then error "Brak rekordu w bazie XT"
		if xt.GetField("zawartosc")!=wKoszu then
			TextOut("Poprawiono ilo wszystkich dokumentw w koszu\n")
			xt.SetField("zawartosc",wKoszu)
			if xt.Update() then error sErrXtNapr
		endif
	endif

endsub

int sub CzyIstRodzaj()

	xt.SetKeySeg( "id", mg.GetField( "rodzaj") )
	CzyIstRodzaj = xt.GetKey( EQ)
	if CzyIstRodzaj then

		xt.SetKey("kod")
		xt.SetKeySeg("typi",64)
		xt.SetKeySeg("kod",mg.GetField("kod"))
		xt.SetKeySeg("super",0)
		CzyIstRodzaj = (xt.GetRec(GE) || xt.GetField("typi")!=64 || xt.GetField("kod")!=mg.GetField("kod") )

		if !CzyIstRodzaj then
			if TextOutAndAsk(2,(using "Rodzaj '%s' ma niewaciwe powizanie z rekordem w bazie XT", xt.GetField( "kod")),". Czy naprawi?" ) then
				mg.SetField( "rodzaj", xt.GetFIeld("id") )
				if mg.Update() then
					TextOut("NIE NAPRAWIONO - bd zapisu do bazy MG\n")
				else
					TextOut("NAPRAWIONO\n")
				endif
			else
				TextOut( sNoRepair )
				CzyIstRodzaj = 1
			endif
		endif
	endif

	xt.SetKey("id")
endsub

int sub DiagWart(string pole, int prec)
float wart
float id

	wart = mg.GetField(pole)
	id = mg.GetField("id")
	if sign(wart-round(wart,prec),6) then
		if TextOutAndAsk(13,(using "Warto pola '%s' posiada cyfry poza wymagan pozycj dokadnoci. Rekord id=%d",pole,id),(". Czy zaokrgli?")) then
			mg.SetField(pole,round(wart,prec))
			UpdateRecB(mg)
		else
			TextOut(sNoRepair)
		endif
	endif
endsub

int sub SprawdzRodzKat()
int okresNr
	OpenBaseB(mg2,"MG")
	OpenBaseB(mg3,"MG" )

	xt.SetKey("id")
	mg.SetKey("numer")
	mg2.SetKey("id")

	// sprawdzenie rodzajw (czy s dla nich rekordy w bazie XT )

	mg.SetKeySeg("typi",99)
	mg.SetKeySeg("kod","")

	err=mg.GetRec(GE)
	while !err && mg.GetKeySeg("typi")==99
		lTemp=mg.GetField("id")
		if lTemp!=3500 then 		// gdy nie jest rootem rodzajw
			if CzyIstRodzaj() then
				if TextOutAndAsk(3,(using "Znaleziono rodzaj dokumentu '%s' o ktrym nie ma informacji w bazie katalogw",mg.GetField("kod")),". Czy naprawi?") then
					if StworzRodzajwXT(mg.GetField("rodzaj"), lTemp, mg.GetField("kod"), mg.GetField("katalog"), mg.GetField("znaczniki")) then
						TextOut(" :  NAPRAWIONO\n")
					else
						TextOut(sErrNapr)
					endif
				else
					TextOut(sNoRepair)
				endif
			endif
		endif
		err=mg.GetRec(NX)
	wend

	// sprawdzanie rodzajw i katalogw wszystkich dokumentw

	mg.SetKey( "id") 
	err=mg.GetRec(FS)
	while !err
		PopUp(2,mg.GetField("kod"))

// sprawdzanie dokladnosci wartosci

		DiagWart("netto",2)
		DiagWart("wartoscWz",2)
		DiagWart("przychod",2)
		DiagWart("rozchod",2)
		DiagWart("wartk",2)

//sprawdzanie okresu
		if mg.getfield("typi") == 201 && mg.getfield("okres") == 0 then
			if TextOutAndAsk(14,(using "Dokument '%s' ma niewaciwy okres numeracji",mg.GetField("kod")),". Czy naprawi?") then
				okresNr = OkresNumeracji(mg.getfield("seria"),mg.getfield("typ_dk"), mg.getfield("data"))
				mg3.SetKey("seria")
				mg3.SetKeySeg("seria",mg.getfield("seria"))
				mg3.SetKeySeg("dzial",mg.getfield("dzial"))
				mg3.SetKeySeg("okres",okresNr)
				mg3.SetKeySeg("serianr",mg.getfield("serianr"))
				if mg3.GetRec(EQ) then
					mg.SetField("okres",okresNr)
				else
					mg.SetField("okres",1)
				endif
				UpdateRecB(mg)
			else
				TextOut(sNoRepair)
			endif
		endif

		iTemp=mg.GetField("typi")
		select case iTemp

		case 201
			xt.SetKeySeg("id",mg.GetField("rodzaj"))
			if xt.GetKey(EQ) then
				if TextOutAndAsk(4,(using "Dokument '%s' jest nieznanego rodzaju",mg.GetField("kod")),(using ". Czy utworzy dla niego rodzaj '@ %l'?",mg.GetField("rodzaj"))) then
					if StworzRodzaj(mg.GetField("rodzaj"),iTemp) then
						TextOut(using " :  NAPRAWIONO - powsta nowy rodzaj '%s'\n",xt.GetField("kod"))
					else
						TextOut(sErrNapr)
					endif
				else
					TextOut(sNoRepair)
				endif
			endif
			xt.SetKeySeg("id",mg.GetField("katalog"))
			if xt.GetKey(EQ) then
				if TextOutAndAsk(5,(using "Dokument '%s' jest w nieznanym katalogu",mg.GetField("kod")),(using ". Czy utworzy dla niego katalog '@ %l'?",mg.GetField("katalog"))) then
					if StworzKatalog(mg.GetField("katalog"),"14","",iTemp) then
						TextOut(using " :  NAPRAWIONO - powsta nowy katalog '%s'\n",xt.GetField("kod"))
					else
						TextOut(sErrNapr)
					endif
				else
					TextOut(sNoRepair)
				endif
			endif
			if mg.GetField("flag")&0x400 && mg.GetField("subtypi")!=0 then
				if mg.GetField("idhandl") && !mg2.GetRecById(-mg.GetField("idhandl")) && mg2.GetField("flag")&0x400 then
					if -mg2.GetFIeld("idhandl")!=mg.GetFIeld("id") then
						TextOut(using"Dokumenty przesunicia magazynowego '%s' oraz '%s' s niepoprawnie skojarzone\n",mg.GetField("kod"),mg2.GetField("kod"))
					else
						if mg.GetField("id")<mg2.GetField("id") then
							if Sign(mg.GetField("netto")+mg2.GetField("netto")) || Sign(mg.GetField("przychod")+mg2.GetField("rozchod")) || Sign(mg.GetField("rozchod")+mg2.GetField("przychod")) then
								TextOut(using"Nie zgadzaj si wartoci netto, przychodu lub rozchodu w dokumentach przesuni magazynowych '%s' id=%l oraz '%s' id=%l.\n",mg.GetField("kod"),mg.GetField("id"),mg2.GetField("kod"),mg2.GetField("id"))
							endif
							if mg.GetField("data")!=mg2.GetField("data") then
								TextOut(using"Nie zgadzaj si daty dokumentw przesuni magazynowych '%s' id=%l oraz '%s' id=%l.\n",mg.GetField("kod"),mg.GetField("id"),mg2.GetField("kod"),mg2.GetField("id"))
							endif
						endif
					endif
				else
					TextOut(using "Brak dokumentu skojarzonego z dokumentem przesunicia magazynowego '%s' id=%l\n",mg.GetField("kod"),mg.GetField("id"))
				endif
			endif

			if mg.GetField("subtypi")==0 && mg.GetField("oki")==0 then
				TextOut(using "Dokument anulowany '%s' jest nadal nierozliczony",mg.GetField("kod"))
				mg.SetField("oki",1)
				UpdateRecB(mg)
			endif

			if (size(RodzDok) > 1) && !(mg.GetField("exp_fki") & 0x20) then
				sTypDk=mg.GetField("typ_dk")
				znacznik=0
				for i=1 to i==size(RodzDok) || znacznik==1
					if sTypDK == RodzDok(i) then znacznik=1
				next i
				if !znacznik then
					msg(imsg)= using"Dokument '%s' posiada nieprawidowy kod '%s'"+lf,mg.GetField("kod"),sTypDk
					grow msg,1
					imsg+=1
				endif
			endif
			if mg.GetField("grupaceni") != 57 then
				mg.SetField("grupaceni",57)
				if mg.Update() then
					msg2(imsg2)=using "UWAGA! Bd zapisu do bazy MG. Nie prawidowa warto pola grupacen dla dokumentu '%s'"+lf,mg.GetField("kod")
					grow msg2, 1
					imsg2+=1
				else
					msg2(imsg2)=using "Poprawiona warto pola grupacen dla dokumentu '%s'"+lf,mg.GetField("kod")
					grow msg2, 1
					imsg2+=1
				endif
			endif 

		case 111		// dok z kosza
			xt.SetKeySeg("id",mg.GetField("katalog"))
			if xt.GetKey(EQ) then
				if TextOutAndAsk(6,(using "Dokument '%s' jest w koszu ktrego nie znaleziono",mg.GetField("kod")),(using ". Czy utworzy dla niego kosz o nazwie '@Kosz %l'?",mg.GetField("katalog"))) then
					if StworzKatalog(mg.GetField("katalog"),"8","Kosz",iTemp) then
						TextOut(using " :  NAPRAWIONO - powsta nowy kosz o nazwie '%s'\n",xt.GetField("kod"))
					else
						TextOut(sErrNapr)
					endif
				else
					TextOut(sNoRepair)
				endif
			endif

			if (size(RodzDok) > 1) && !(mg.GetField("exp_fki") & 0x20) then
				sTypDk=mg.GetField("typ_dk")
				znacznik=0
				for i=1 to i==size(RodzDok) || znacznik==1
					if sTypDK == RodzDok(i) then znacznik=1
				next i
				if !znacznik then
					msg(imsg)= using"Dokument '%s' z kosza posiada nieprawidowy kod '%s'"+lf,mg.GetField("kod"),sTypDk
					grow msg, 1
					imsg+=1
				endif
			endif
			if mg.GetField("grupaceni") != 13 then
				mg.SetField("grupaceni",13)
				if mg.Update() then
					msg2(imsg2)=using "UWAGA! Bd zapisu do bazy MG. Nie prawidowa warto pola grupacen dla dokumentu '%s'"+lf,mg.GetField("kod")
					grow msg2, 1
					imsg2+=1
				else
					msg2(imsg2)=using "Poprawiona warto pola grupacen dla dokumentu '%s'"+lf,mg.GetField("kod")
					grow msg2, 1
					imsg2+=1
				endif
			endif 
		endselect

		err=mg.GetRec(NX)
	wend

	mg2.Close()
	mg3.Close()

endsub

int sub OdzyskDok()
long lTemp, lTemp2
string sTemp

	nextDiagDok=1

	// ustalenie nastepnego numeru odzyskiwanych dokumentw
	mg.SetKey("seria")
	mg.SetKeySeg("seria",DOK_DIAG)
	err=mg.GetRec(GE)
	while !err && mg.GetKeySeg("seria")==DOK_DIAG
		nextDiagDok=mg.GetField("serianr")+1
		err=mg.GetRec(NX)
	wend

	OpenBaseB( mg2,"MG" )
	OpenBaseB( mg3,"MG" )

	SetKey(kh,"id")
	SetKey(mz,"super")
	mg.SetKey("id")
	mg2.SetKey("numer")
	mg3.SetKey("id")
	mg2.SetKeySeg("typi",101)
	xt.SetKey("super")
	SetKey(mz2,"id")
	SetKeySeg(mz,"lp",0)

	err=GetRec(mz,LS)
	while !err
		PopUp(2,(using "dokumenty z dnia %s",GetField(mz,"data")))
		super=GetField(mz,"super")
		mg.SetKeySeg("id",super)
		if mg.GetRec(EQ) then
			if TextOutAndAsk(7,(using "Brak dokumentu z dnia %s na ktrym znajduje sie pozycja '%s'",GetField(mz,"data"),GetField(mz,"opis")),". Czy naprawi?") then
				// nie ma dokumentu -> odtwarzam
				mg.Clear()
				mg.SetField("id",super)
				mg.SetField("data",GetField(mz,"data"))
				mg.SetField("datasp",GetField(mz,"data"))
				mg.SetField("khid",GetField(mz,"idkh"))
				mg.SetField("typi",GetField(mz,"subtypi"))
				mg.SetField("magazyn",GetField(mz,"magazyn"))
				mg.SetField("katalog",2500)
				mg.SetField("rodzaj", 3500 )

				// odtwarzanie danych o kontrahencie
				SetKeySeg(kh,"id",GetField(mz,"idkh"))
				if GetRec(kh,EQ) then
					bezKontr=1
				else
					bezkontr=0
					// przepisanie danych o kontrahencie
					mg.SetField("khkod",GetField(kh,"kod"))
					mg.SetField("khnazwa",GetField(kh,"nazwa"))
					mg.SetField("khadres",GetField(kh,"ulica"))
					mg.SetField("khdom",GetField(kh,"dom"))
					mg.SetField("khlokal",GetField(kh,"lokal"))
					mg.SetField("khmiasto",GetField(kh,"miejscowosc"))
					mg.SetField("khkodpocz",GetField(kh,"kodpocz"))
					mg.SetField("khnip",GetField(kh,"nip"))
				endif

				// ustawienie serii i numeru dokumentu
				mg.SetField("kod",(using "%s - %s - %d",DOK_DIAG,mg.GetField("data"),nextDiagDok))
				mg.SetField("nazwa",mg.GetField("kod"))
				mg.SetField("seria",DOK_DIAG)
				mg.SetField("serianr",nextDiagDok)
				mg.SetField("subtypi",89)		// nie znamy wic przyjcie do magazynu
				nextDiagDok+=1

				// poczenie do ewentualnej korekty
				if GetField(mz,"idpozkoryg") then
					// jest korekt
					// znalezienie dok korygowanego

					SetKey(mz2,"id")
					SetKeySeg(mz2,"id",GetField(mz,"idpozkoryg"))
					err=GetRec(mz2,EQ)
					while !err && GetField(mz2,"idpozkoryg")
						SetKeySeg(mz2,"id",GetField(mz2,"idpozkoryg"))
						err=GetRec(mz2,EQ)
					wend
					if !err then
						mg.SetField("iddokkoryg",GetField(mz2,"super"))

						// docz do listy (w tabeli)
						if iloscKorBr then
							grow korygowaneBrak,1
							grow rooty,1
						endif
						iloscKorBr+=1
						korygowaneBrak(iloscKorBr)=super
						rooty(iloscKorBr)=GetField(mz2,"super")
					endif

				else
					// moe by dok korygowanym -> uzupeniam liste dok korygujcych
					lTemp=iloscKorBr
					while lTemp>0 && rooty(lTemp)!=super
						lTemp-=1
					wend
					if lTemp>0 then
						// jest dokumentem korygowanym
						mg.SetField("idkorekt",korygowaneBrak(lTemp))

						err=0
						while !err && lTemp>0
							mg3.SetKeySeg("id",korygowaneBrak(lTemp))
							err=mg3.GetRec(EQ)
							if !err then
								lTemp-=1
								while lTemp>0 && rooty(lTemp)!=super
									lTemp-=1
								wend
								if lTemp>0 then
									mg3.SetField("idkorekt",korygowaneBrak(lTemp))
									if mg3.Update() then Error "Bd zapisu do bazy mg"
								endif
							endif
						wend
					endif
				endif

				// naliczenie netto
				netto=0
				do
					netto+=GetField(mz,"wartNetto")
					err=GetRec(mz,PR)
				loop until err || GetKeySeg(mz,"super")!=super
				SetKeySeg(mz,"super",super)
				mg.SetField("netto",netto)

				if mg.Insert() then
					TextOut(sNoRepair)
				else
					ZapiszGwiazdki()
					TextOut(using "Utworzono nowy dokument o kodzie '%s'",mg.GetField("kod"))
					buf = " - bez danych o kontrahencie"
					if !bezKontr then buf += "\n"
					TextOut(buf)
				endif
				SetKeySeg(mz,"super",super)
			else
				TextOut(sNoRepair)
			endif
		else
			if mg.GetField("typi")==99 then
				TextOut(using "Pozycja '%s' id=%l jest dowizana do rekordu rodzaju '%s'. Odtworzenie dokumentu jest niemoliwe.\n",GetField(mz,"kod"),GetField(mz,"id"),mg.GetField("kod"))
			else
				if !(mg.GetField("flag")&0x400) && mg.GetField("subtypi")!=90 && (mg.GetField("idhandl")!=0 || GetField(mz,"idhandl")!=0) then
					lTemp=GetField(mz,"idhandl")
					lTemp2=mg.GetField("idhandl")

					sTemp="DP"
					if lTemp<0 then sTemp="BP" : lTemp=-lTemp 
					basTemp.SetBase(sTemp)
					if !basTemp.GetRecById(lTemp) then
						lTemp = basTemp.GetField("super")
					else
						lTemp = 0
					endif
					
					sTemp="DK"
					if lTemp2<0 then sTemp="BD" : lTemp2=-lTemp2
					basTemp.SetBase(sTemp)
						
					if lTemp2==0 || basTemp.GetRecById(lTemp2) || (lTemp && (lTemp != basTemp.GetField("id"))) then
						if TextOutAndAsk(8,(using "Dokument '%s' id=%l bdnie odwouje si do dokumentu handlowego.",mg.GetField("kod"),mg.GetField("id")),("\nCzy naprawi?")) then
							mg.SetField("idhandl",lTemp)
							UpdateRecB(mg)
						else
							TextOut(sNoRepair)
						endif
					endif			
				endif
				// pozycje dodane do korekty, ktore nie koryguja dokumentu zrodlowego, maja idpozkoryg == 0
				// if GetField(mz,"idpozkoryg") then
				if mg.GetField("iddokkoryg") then
					if !err then
						// docz do listy (w tabeli)
						if iloscKorBr then
							grow korygowaneBrak,1
							grow rooty,1
						endif
						iloscKorBr+=1
						korygowaneBrak(iloscKorBr)=super
						rooty(iloscKorBr)=mg.GetField("iddokkoryg")
					endif
				else
					// moe by dok korygowanym -> uzupeniam liste dok korygujcych
					lTemp=iloscKorBr
					while lTemp>0 && rooty(lTemp)!=super
						lTemp-=1
					wend
					if lTemp>0 then
						// jest dokumentem korygowanym
						mg.SetField("idkorekt",korygowaneBrak(lTemp))
						if mg.Update() then Error "Bd zapisu do bazy MG"
						err=0
						while !err && lTemp>0
							mg3.SetKeySeg("id",korygowaneBrak(lTemp))
							err=mg3.GetRec(EQ)
							if !err then
								lTemp-=1
								while lTemp>0 && rooty(lTemp)!=super
									lTemp-=1
								wend
								if lTemp>0 then
									mg3.SetField("idkorekt",korygowaneBrak(lTemp))
									if mg3.Update() then Error "Bd zapisu do bazy mg"
								endif
							endif
						wend
					endif
				endif
			endif
		endif
		SetKeySeg(mz,"lp",-32768)
		err=GetRec(mz,LT)
	wend

	mg2.Close()
	mg3.close()
endsub

// ************** main
if ((firma.code != "HM") && (firma.code != "HL")) then error "Raport moe zosta wykonany tylko dla wersji Handlu"

OpenBaseB(xt,"XT")
kh = OpenBase("kh")
OpenBaseB(mg,"MG")
mz = OpenBase("mz")
mz2=OpenBase( "mz" )

TextOut("Podsumowanie sprawdzania poprawnoci bazy dokumentw magazynowych\n\n")

SprawdzTypyDok(7016)

if StageT(1) then SprawdzWzorcowa()
StageSummary(1)

OpenBaseB(mg2,"MG")
if StageT(2) then SprawdzIMG()
StageSummary(2)
mg2.close()

if StageT(3) then

	// sprawdzenie czy dla rekordw rodzajw z bazy XT istniej odpowiednie w bazie MG

	ZliczRodzaje(1)

	// sprawdzenie rootw katalogw i rodzajw

	xt.SetKey("id")
	mg.SetKey("id")

	SprawdzRooty()	

	// sprawdzenie, czy kady dokument ma swj rodzaj i katalog

	PopUp(1,"Sprawdzanie rodzajw i katalogw")
	SprawdzRodzKat()

	StageSummary(3)

endif

// odtwarzanie dokumentw na postawnie pozycji dokumentw
WriteStatusBar("Sprawdzanie dokumentw na podstawie pozycji dokumentw")
PopUp(1,"Sprawdzanie dokumentw:")

if StageT(4) then
	OdzyskDok()
	PopUp(1,"")
	PopUp(2,"")
	SprawdzDokumenty()
	StageSummary(4)
endif

// sprawdzenie, czy zgadzaj si ceny w dokumentach z sum pozycji
PopUp(1,"Sprawdzanie wartoci w dokumentach")
PopUp(2,"")
WriteStatusBar("Sprawdzanie wartoci w dokumentach")

SetKey(mz,"super")
SetKeySeg(mz,"super",0)
SetKeySeg(mz,"lp",0)
mg.SetKey("id")

if StageT(5) then

progress.Reset(mg.GetRecordCount())
do
	fPrzychod=fRozchod=netto=0

	err=GetRec(mz,GE)
	progress.NextOne()
	if !err then
		super=GetField(mz,"super")
		while !err && GetKeySeg(mz,"super")==super
			if GetField(mz,"typi")!=1 then		// 1=komplet lub anulowano
				netto+=GetField(mz,"wartNetto")
				fPrzychod+=GetField(mz,"przychod")
				fRozchod+=GetField(mz,"rozchod")
			endif
			err=GetRec(mz,NX)
		wend
		SetKeySeg(mz,"lp",0)
		SetKeySeg(mz,"super",super+1)
		mg.SetKeySeg("id",super)
		if !mg.GetRec(EQ) then
			if mg.GetField("subtypi")==0 && (fPrzychod || fRozchod) then
				iloscPW=wartoscPW=0
				super2=mg.GetField("id")
				SetKey(mz2,"super")
				SetKeySeg(mz2,"super",super2)
				SetKeySeg(mz2,"lp",0)
				err=GetRec(mz2,GE)
				while !err && GetKeySeg(mz2,"super")==super2 && !iloscPW && !wartoscPW
					if GetField(mz2,"typi")!=1 then		// 1=komplet lub anulowano
						idmg=GetField(mz2,"id")
						SetKey(pw2,"dostawy")
						SetKeySeg(pw2,"typi",37)
						SetKeySeg(pw2,"idmg",idmg)
						SetKeySeg(pw2,"iddw",0)
						err=GetRec(pw2,GE)
						while !err && GetField(pw2,"typi")==37 && GetField(pw2,"idmg")==idmg && !iloscPW && !wartoscPW
							iloscPW += GetField(pw2,"ilosc")
							wartoscPW += GetField(pw2,"wartosc")
							err=GetRec(pw2,NX)
						wend
					endif
					err=GetRec(mz2,NX)
				wend
				if iloscPW || wartoscPW then
					PopUp(2,mg.GetField("kod"))
					if TextOutAndAsk(15,(using "Dokument '%s' jest bdnie oznaczony jako anulowany",mg.GetField("kod")),". Czy naprawi?") then
						mg.SetField("subtypi",89)		// nie znamy wic przyjcie do magazynu
						UpdateRecB(mg)
					else
						TextOut(sNoRepair)
					endif
				endif
			endif
			if mg.GetField("subtypi")!=0 && mg.GetField("subtypi")!=2 then
				PopUp(2,mg.GetField("kod"))
				if Sign(mg.GetField("przychod")-fPrzychod,2) || Sign(mg.GetField("rozchod")-fRozchod,2) then	
					if TextOutAndAsk(12,(using"Nie zgadza si warto przychodu lub rozchodu w dokumencie '%s'",mg.GetField("kod")),(using ".\nPrzychd: jest %.2f  powinno by %.2f\nRozchd: jest %.2f  powinno by %.2f\nCzy zapisa poprawne wartoci?",mg.GetField("przychod"),fPrzychod,mg.GetField("rozchod"),fRozchod)) then
						mg.SetField("przychod",fPrzychod)
						mg.SetField("rozchod",fRozchod)
						UpdateRecB(mg)
					else
						TextOut(sNoRepair)
					endif
				endif
				if Sign(mg.GetField("netto")-netto,2) then
					ZapiszGwiazdki()
					TextOut(using "Nie zgadza si warto netto w dokumencie '%s'\n",mg.GetField("kod"))
				endif
				if Sign(mg.GetField("netto")-(mg.GetField("przychod")+mg.GetField("rozchod")),2) then
					ZapiszGwiazdki()
					TextOut(using "Nie zgadza si warto netto z sum przychodu i rozchodu w dokumencie '%s'\n",mg.GetField("kod"))
				endif
			endif
		endif
	endif
	
loop until err

StageSummary(5)
endif // stage

int sub AskAndOdtworzRekZZ(int typ, int askk, string ss, int nFlag)
	zz.SetKeySeg("typi",typ)
	zz.SetKeySeg("baza1",33)
	zz.SetKeySeg("id1",mg.GetField("id"))
	zz.SetKeySeg("baza2",0)
	zz.SetKeySeg("id2",0)
	if !zz.GetRec(GE) && zz.GetKeySeg("typi")==typ && zz.GetKeySeg("baza1")==33 && zz.GetKeySeg("id1")==mg.GetField("id") then 
		if zz.GetField("termin") != mg.GetField("termin") then
			if TextOutAndAsk3(askk,(using "Dokument '%s' id=%l posiada bdny rekord dokumentu %s nierozliczonego magazynowo w bazie ZZ",mg.GetField("kod"),mg.GetField("id"),ss)) then
				zz.SetField("termin", mg.GetField("termin"))
				UpdateRecB(zz)
			else
				TextOut(sNoRepair)
			endif
		endif
		exit
	endif
	if TextOutAndAsk3(askk,(using "Dokument '%s' id=%l nie posiada rekordu dokumentu %s nierozliczonego magazynowo w bazie ZZ",mg.GetField("kod"),mg.GetField("id"),ss)) then
		zz.Clear()
		zz.SetField("typi",typ)
		zz.SetField("flag",nFlag)
		zz.SetField("baza1",33)
		zz.SetField("id1",mg.GetField("id"))
		zz.SetField("baza2",20)
		zz.SetField("id2",mg.GetField("magazyn")*0x1000000+mg.GetField("khid"))
		zz.SetField("kod1",mg.GetField("kod"))
		zz.SetField("kod2",mg.GetField("khkod"))
		zz.SetField("data",mg.GetField("data"))
		zz.SetField("termin",mg.GetField("termin"))
		zz.SetField("cena",mg.GetField("netto"))
		zz.SetField("opis",mg.GetField("nazwa"))
		zz.SetField("magazyn",mg.GetField("magazyn"))
		InsertRecB(zz)
	else
		TextOut(sNoRepair)
	endif
endsub

PopUp(1,"Sprawdzanie rozlicze magazynowych")
PopUp(2,"")
OpenBaseB(zz,"ZZ")
zz.SetKey("cross1")
mg.SetKey("id")
err=mg.GetRec(FS)
progress.Reset(mg.GetREcordCount())

if !StageT(6) then err=1
int nFlag

while !err
	progress.NextOne()
	nFlag = 0

	if mg.GetField("typi")==201 then
		err=1
		buf = using "%d",mg.GetField("subtypi")

		if mg.GetField("oki") != 0 then err = 0

		if err then
			nFlag = mg.GetField("iddokkoryg") != 0 
			if !nFlag then
				if mg.GetField("idhandl") > 0 then
					nFlag = 1
				else
					if mg.GetField("idhandl") < 0 then
						if mg.GetField("flag") & 0x0400 then
							nFlag = 1
						endif
					endif
				endif
			endif
		endif

		if err then		// powinien by rekord
			select case mg.GetField("subtypi")
				case 78,88	//WZ,WZK
					AskAndOdtworzRekZZ(0x85, 8, "wydania zewntrznego", nFlag)
				case 89,81 //PZ,PZK
					AskAndOdtworzRekZZ(0x86, 9, "przyjcia zewntrznego", nFlag)
				case 76,84,77,85 // RW
					AskAndOdtworzRekZZ(0x87, 10, "rozchodu wewntrznego", nFlag)
				case 74,82,75,83,90,91	// PW,MM+,PWK,MPK,KWM,PWM
					AskAndOdtworzRekZZ(0x88, 11, "przychodu wewntrznego", nFlag)
			endselect
		endif
	endif
	err=mg.GetRec(NX)
wend

StageSummary(6)
if imsg > 1 then
	for imsg = 1 to imsg == size(msg)
		print msg(imsg)
	next imsg
endif
if imsg2 > 1 then
	for imsg2 = 1 to imsg2 == size(msg2)
		print msg2(imsg2)
	next imsg2
endif
TextOut("\nZakoczono.")

ShowFileInfo()
if bylyGw then
	TextOut("\nUWAGA!!! Odtworzone przez program dane mog by (i najprawdopodobniej s) NIEKOMPLETNE!\n")
	TextOut("Prosz wydrukowa powysze podsumowanie a nastpnie sprawdzi poprawno wszystkich odtworzonych danych wyrnionych w tym podsumowaniu przez ")
	ZapiszGwiazdki()
endif
close

buf = IIF( GetVError() == 0 , "" , "errorDiagMG" )