//"diag_pw.sc","51pw : diagnostyka rozlicze magazynowych",12004,0,1.0.3,SYSTEM
//"Diagnostyka",12001,14,16
//////////////////////////
// 51pw : diagnostyka rozlicze magazynowych
// diag_pw.sc
//////////////////////////////
// napisa: Sebastian Nowak
// data:    99.01.28

string NAZWA_PLIKU = "diag_pw.txt"
string sRaportDescription

#include "Diagnostyka - funkcje"
UsunRekord_0("PW")

sDialogTitle += "przyj/wyda PW"

StageAddDesc("Raport sprawdza oraz ewentualnie odtwarza rekordy przyj/wyda")
StageAddDesc("magazynowych dla pozycji dokumentw magazynowych, rezerwacji ilociowych")
StageAddDesc("oraz wartociowych")
StageAddStage("Dopenianie rekordw PW od strony pozycji magazynowych")
StageAddStage("Uzupenianie rekordw PW rozliczajcych dostawy")
StageAddStage("Uzupenianie rekordw PW rozliczajcych pozycje magazynowe")
StageAddStage("Uzupenianie rekordw PW rozliczajcych pozostae pozycje magazynowe")
StageAddStage("Sprawdzanie spjnoci towarw i magazynw")
ChooseStages(400)

int mz,pw,dw,zz,bZostalo,bTemp,i,mg,dp,bp,bz,xt, nFlag, bIlosciowa, bRozne
long iddw,idx,ilosc_tow,idtw,lTemp 
int ret	//zmienna pomocnicza

record recInfo
	float ilosc
	float wartosc
	int magazyn
	long id
	long pNext		// wskanik na nastpny rekord w tablicy
	long super		// super dla pozycji magazynowej
endrec

long tIdtw(1)				// id towarw
long tStartIdx(1)		// indeksy poczatku listy dla danego towaru
long tLastIdx(1)		// indeksy ostatniego rekordu na licie dla danego towaru
recInfo tToAdd(1)	// dla kadego towaru lista rekordw dostaw niekompletnych
long tSubAll(1), tSubSet(1)
long lSubSet

float ilosc,iloscR,iloscS
float wartosc,wartoscR,wartoscS

//************************
#include "Diagnostyka rozlicze magazynowych - include"

TextOut("Podsumowanie sprawdzania poprawnoci bazy przyj/wyda magazynowych\n\n")

mz = OpenBase("mz")
mg = OpenBase("mg")
pw = OpenBase("pw")
dw = OpenBase("dw")
zz = OpenBase("zz")
dp = OpenBase("dp")
bp = OpenBase("bp")
bz = OpenBase("bz")
xt = OpenBase("xt")
//---------------------------------------------------------------------------------------------
//	Dopenianie rekordw PW od strony pozycji magazynowych.
//	-	szukam rekordw PW dla danego rekordu MZ.
//		-	jeli bdzie niezgodny i bdzie tylko jeden to uzupeniam rekord PW
//---
//	Przypadki nie rozpatrzone
//	-	brak rekordu PW
//	-	kilka rekordw PW

int dk = OpenBase("dk")
string strSeria = "id"

SetKey(dk, "seria")
SetKeySeg(dk, "seria", strSeria)
SetKeySeg(dk, "serianr", 99999)

string dataP = ""
if !GetRec(dk, LT) && GetField(dk, "seria") == strSeria then
	dataP = GetField(dk, "datasp")	//data przecicia jeli bya przeprowadzana archiwizacja
endif

close dk

IF StageT(1) THEN
	PopUp(1,"Sprawdzanie pozycji dokumentw magazynowych")
	SetKey(pw,"dostawy")
	SetKeySeg(mz,"id",0)
	err = GetRec(mz,FS)
	SetKey(mg,"id")
	progress.Reset(GetRecordCount(mz))
	while !err
		progress.NextOne()
		PopUp(2,GetField(mz,"kod"))
		if (dataP < GetField(mz,"data")) then
			// zliczam czy ma rnic wartoci z rekordami PW
			ilosc = wartosc = 0
			ret = CountPWforMZ(GetField(mz,"id"),37,0,GetField(mz,"data"))
			iloscR = ilosc-GetField(mz,"ilosc")
			wartoscR = wartosc - GetField(mz,"wartNetto")
			IF !(GetField(mz,"typi")&0x01) THEN
				IF (Sign(iloscR,4) || Sign(wartoscR)) && ret==1 THEN
					// brakuje -> szukam pasujcej i naprawiam
					buf = "NIE ZNALEZIONO DOKUMENTU"
					SetKeySeg(mg,"id",GetField(mz,"super")) : if !GetRec(mg,EQ) then buf = GetField(mg,"kod")
					ret = TextOutAndAsk(7,(using "Niepeny rekord wyda w bazie PW dla pozycji '%s' id=%l dokumentu '%s' na ilo %.2f i warto %.2f",GetField(mz,"kod"),GetField(mz,"id"),buf,-iloscR,-wartoscR),". Czy dopeni rekord PW?")
					IF ret THEN
						ret = GetField(mz,"id")
						SetKeySeg(pw,"typi",37)
						SetKeySeg(pw,"idmg",GetField(mz,"id"))
						SetKeySeg(pw,"iddw",0)
						IF !GetRec(pw,GE) THEN
							SetField(pw, "ilosc", GetField(mz,"ilosc"))
							SetField(pw, "wartosc", GetField(mz,"wartNetto"))
							UpdateRec(pw, "PW")
						ENDIF
					ELSE
						TextOut( sNoRepair )
					ENDIF
				ENDIF
			ELSE
				IF ret THEN
					// przypadek istnienia dla pozycji anulowanych rekordow w bazie PW
					// propozycja usuniecia rekordow PW
					buf = "NIE ZNALEZIONO DOKUMENTU"
					SetKeySeg(mg,"id",GetField(mz,"super")) : if !GetRec(mg,EQ) then buf = GetField(mg,"kod")
					ret = TextOutAndAsk(14,(using "Znaleziono rekord w bazie PW dla pozycji anulowanej '%s' id=%l dokumentu '%s'",GetField(mz,"kod"),GetField(mz,"id"),buf),".\nCzy usun rekord z bazy PW")
					IF ret THEN
						DeletePWforMZ( GetField(mz,"id"),37)
					ELSE
						TextOut(sNoRepair)
					ENDIF
				ENDIF
			ENDIF
		endif
		err = GetRec(mz,NX)
	wend

	StageSummary(1)
ENDIF

//---------------------------------------------------------------------------------------------

// znalezienie i porwnanie brakw na podstawie bazy MZ i DW

if StageT(2) then

// tworzenie list brakw od strony bazy DW
PopUp(1,"Sprawdzanie spjnoci rekordw przyj/wyda z dostawami")
bTemp = 1
SetKey(mz,"id")
SetKey(dw,"id")
SetKey(pw,"pozycje")
err = GetRec(dw,FS)
progress.Reset(GetRecordCount(dw))
while !err
	PopUp(2,GetField(dw,"kod"))
	progress.NextOne()
	if GetField(dw,"numer")>0 && GetField(dw,"idtw")>0 then
		idtw = GetField(dw,"idtw")
		// zliczenie wszystkich wyda dla tej dostawy
		ilosc = wartosc = 0
		CountPW(GetField(dw,"id"),37,0)
		CountPW(GetField(dw,"id"),26,0)
		iloscR = ilosc+GetField(dw,"iloscdosp")
		wartoscR = wartosc + GetField(dw,"wartoscdosp")
		if Sign(iloscR,4) || Sign(wartoscR) then
			if bTemp then bTemp=0 : TextOut("Zbieranie informacji o braku rekordw PW dla dostaw\n")
			idx = GetIndex(idtw)
			if !idx then
				if ilosc_tow then grow tToAdd,1 : grow tIdtw,1 : grow tStartIdx,1 : grow tLastIdx,1
				ilosc_tow += 1
				idx = ilosc_tow
				tStartIdx(idx)=size(tToAdd)
				tLastIdx(idx)=size(tToAdd)
				tIdTw(idx)=idtw
			else
				lTemp = tLastIdx(idx)
				grow tToAdd,1
				tToAdd(lTemp).pNext = size(tToAdd)
				tLastIdx(idx) = size(tToAdd)
			endif
			tToAdd(tLastIdx(idx)).ilosc = iloscR
			tToAdd(tLastIdx(idx)).wartosc = wartoscR
			tToAdd(tLastIdx(idx)).magazyn = GetField(dw,"magazyn")
			tToAdd(tLastIdx(idx)).id = GetField(dw,"id")
			TextOut(using"Brak rekordw wyda PW dla dostawy '%s' id=%l na ilo %.2f i warto %.2f\n",GetField(dw,"kod"),GetField(dw,"id"),-iloscR,-wartoscR)
		endif

	endif
	err = GetRec(dw,NX)
wend


// szukanie po rezerwacji i uzupenianie rekordw PW
SetKey(pw,"dostawy")
SetKey(zz,"cross1")
SetKey(dw,"towar")
SetKey(mz,"id")
SearchZZforTyp(96)
SearchZZforTyp(98)


// szukanie po pozycjach i uzupenianie rekordw PW
PopUp(1,"Sprawdzanie pozycji dokumentw magazynowych")
SetKey(pw,"dostawy")
SetKeySeg(mz,"id",0)
err = GetRec(mz,FS)
SetKey(mg,"id")
SetKey(xt,"id")
progress.Reset(GetRecordCount(mz))
while !err
	SetKeySeg(xt,"id",GetField(mz,"magazyn"))
	if !GetRec(xt,EQ) && !(GetField(xt,"flag")&0x10) then
		progress.NextOne()
		PopUp(2,GetField(mz,"kod"))
		if !(GetField(mz,"typi")&0x01) then
			// zliczam czy ma rnic wartoci z rekordami PW
			ilosc = wartosc = 0
			CountPWforMZ(GetField(mz,"id"),37,0,"")
			iloscR = ilosc-GetField(mz,"ilosc")
			wartoscR = wartosc - GetField(mz,"wartNetto")
			if Sign(iloscR,4) || Sign(wartoscR) then
				// brakuje -> szukam pasujcej i naprawiam
				buf = "NIE ZNALEZIONO DOKUMENTU"
				SetKeySeg(mg,"id",GetField(mz,"super")) : if !GetRec(mg,EQ) then buf = GetField(mg,"kod")
				if TextOutAndAsk(7,(using "Brak rekordw wyda w bazie PW dla pozycji '%s' id=%l dokumentu '%s' na ilo %.2f i warto %.2f",GetField(mz,"kod"),GetField(mz,"id"),buf,-iloscR,-wartoscR),". Czy doda rekord do bazy PW?") then
					Repair()
				else
					TextOut( sNoRepair )
				endif
			endif
		endif
	endif
	err = GetRec(mz,NX)
wend

// nic nie powinno zosta

SetKey(dw,"id")
bZostalo=0
for idx=1 to idx>ilosc_tow
	lTemp = tStartIdx(idx)
	while lTemp
		if Sign(tToAdd(lTemp).ilosc,4) || Sign(tToAdd(lTemp).wartosc) then
			SetKeySeg(dw,"id",tToAdd(lTemp).id)
			GetRec(dw,EQ)
			TextOut(using "*** Dostawa '%s' id=%l nadal nie posiada wszystkich dowiza rekordw PW.\n",GetField(dw,"kod"),GetField(dw,"id"))
			bZostalo=1
		endif
		lTemp=tToAdd(lTemp).pNext
	wend	
next idx

StageSummary(2)

endif // stage


if StageT(3) then

// a od strony dostaw dla pozycji przychodowych
// szukanie brakujacych rekordw PW dla pozycji przyj do magazynu
PopUp(1,"Sprawdzanie przyj do magazynu")
ilosc_tow=0
shrink tIdtw,-1
tIdtw(1)=0
shrink tStartIdx,-1
tStartIdx(1)=0
shrink tLastIdx,-1
tLastIdx(1)=0
shrink tToAdd,-1
tToAdd(1).ilosc = 0
tToAdd(1).wartosc = 0
tToAdd(1).magazyn = 0
tToAdd(1).id = 0
tToAdd(1).pNext = 0
tToAdd(1).super	= 0

// tworzenie list brakw od strony pozycji magazynowych
bTemp=1
SetKey(mz,"id")
SetKey(pw,"dostawy")
SetKey(xt,"id")
err=GetRec(mz,FS)
progress.Reset(GetRecordCount(mz))
while !err
	PopUp(2,GetField(mz,"kod"))
	progress.NextOne()
	SetKeySeg(xt,"id",GetField(mz,"magazyn"))
	if !(GetField(mz,"typi")&0x01) && !GetRec(xt,EQ) && !(GetField(xt,"flag")&0x10) then
		SetKeySeg(pw,"typi",37)
		SetKeySeg(pw,"idmg",GetField(mz,"id"))
		SetKeySeg(pw,"iddw",0)
		iloscR = wartoscR = 0
		if GetRec(pw,GE) || GetField(pw,"typi")!=37 || GetField(pw,"idmg")!=GetField(mz,"id") then
			if Sign(GetField(mz,"ilosc"),4) || Sign(GetField(mz,"wartNetto")) then
				// nie ma rekordu PW dla tej pozycji -> wpisuj na list
				idtw = GetField(mz,"idtw")
				idx = GetIndex(idtw)
				if !idx then
					if ilosc_tow then grow tToAdd,1 : grow tIdtw,1 : grow tStartIdx,1 : grow tLastIdx,1
					ilosc_tow += 1
					idx = ilosc_tow
					tStartIdx(idx)=size(tToAdd)
					tLastIdx(idx)=size(tToAdd)
					tIdTw(idx)=idtw
				else
					lTemp = tLastIdx(idx)
					grow tToAdd,1
					tToAdd(lTemp).pNext = size(tToAdd)
					tLastIdx(idx) = size(tToAdd)
				endif
				tToAdd(tLastIdx(idx)).ilosc = -GetField(mz,"ilosc")
				tToAdd(tLastIdx(idx)).wartosc = -GetField(mz,"wartNetto")
				tToAdd(tLastIdx(idx)).magazyn = GetField(mz,"magazyn")
				tToAdd(tLastIdx(idx)).id = GetField(mz,"id")
				tToAdd(tLastIdx(idx)).super = GetField(mz,"super")
				if bTemp then bTemp=0 : TextOut("Zbieranie informacji o braku rekordw PW dla pozycji magazynowych przychodowych\n")
				TextOut(using"Brak rekordw wyda PW dla pozycji dokumentu magazynowego '%s' id=%l na ilo %.2f i warto %.2f\n",GetField(mz,"kod"),GetField(mz,"id"),-GetField(mz,"ilosc"),-GetField(mz,"wartNetto"))
			endif
		endif
	endif
	err = GetRec(mz,NX)
wend

// szukanie po pozycjach i uzupenianie rekordw PW
PopUp(1,"Sprawdzanie dostaw")
SetKey(dw,"towar")
SetKeySeg(dw,"idtw",0)
SetKey(pw,"pozycje")
SetKey(mz,"id")
err = GetRec(dw,FS)
progress.Reset(GetRecordCount(dw))
while !err
	PopUp(2,GetField(dw,"kod"))
	progress.NextOne()
	if GetField(dw,"numer")>0 then
		ilosc = wartosc = 0
		if GetField(dw,"idtw")>0 then
			CountPW(GetField(dw,"id"),37,0)
			CountPW(GetField(dw,"id"),26,0)
		else
			CountPW(GetField(dw,"id"),39,0)
		endif
		iloscR = ilosc+GetField(dw,"iloscdosp")
		wartoscR = wartosc + GetField(dw,"wartoscdosp")
		if Sign(iloscR,4)<0 || Sign(wartoscR)<0 then 
			TextOutAskOkEnd(13,using "Suma wartoci lub iloci pozycji przyj do magazynu dla dostawy '%s' jest wiksza ni warto lub ilo tej dostawy.\n",GetField(dw,"kod"))
		else
			if Sign(iloscR,4) || Sign(wartoscR) then
				if TextOutAndAsk(3,(using "Brak rekordw rozlicze z bazy PW dla dostawy '%s' id=%l na ilo %.2f i warto %.2f",GetField(dw,"kod"),GetField(dw,"id"),iloscR,wartoscR),". Czy znale pozycje dokumentw magazynowych przychodowych?") then
					// brakuje -> szukam pasujcej i naprawiam
					RepairDW()
				else
					TextOut( sNoRepair )
				endif
			endif
		endif
	endif
	err = GetRec(dw,NX)
wend

// te pozycje ktre zostay doczymy do wielu dostaw -> zachowamy id-y

lSubSet=0
shrink tSubSet,-1
tSubSet(1)=0
for idx=1 to idx>ilosc_tow
	lTemp = tStartIdx(idx)
	while lTemp
		if Sign(tToAdd(lTemp).ilosc,4) || Sign(tToAdd(lTemp).wartosc) then
			if lSubSet then grow tSubSet,1
			lSubSet+=1
			tSubSet(lSubSet)=tToAdd(lTemp).id
		endif
		lTemp=tToAdd(lTemp).pNext
	wend	
next idx

StageSummary(3)

endif // stage

// pozostae pozycje magazynowe czone s z wieloma rekordami DW
// zbieranie informacji o niekompletnych dostawach


if StageT(4) then

PopUp(1,"Wyszukiwanie niekompletnych dostaw")
bTemp = 1
ilosc_tow=0
shrink tIdtw,-1
tIdtw(1)=0
shrink tStartIdx,-1
tStartIdx(1)=0
shrink tLastIdx,-1
tLastIdx(1)=0
shrink tToAdd,-1
tToAdd(1).ilosc = 0
tToAdd(1).wartosc = 0
tToAdd(1).magazyn = 0
tToAdd(1).id = 0
tToAdd(1).pNext = 0
tToAdd(1).super	= 0

SetKey(mz,"id")
SetKey(dw,"id")
SetKey(pw,"pozycje")
err = GetRec(dw,FS)
progress.Reset(GetRecordCount(dw))
while !err
	PopUp(2,GetField(dw,"kod"))
	progress.NextOne()
	if GetField(dw,"numer")>0 && GetField(dw,"idtw")>0 then
		idtw = GetField(dw,"idtw")
		// zliczenie wszystkich przyj do tej dostawy
		ilosc = wartosc = 0
		CountPW(GetField(dw,"id"),37,0)
		CountPW(GetField(dw,"id"),26,0)
		iloscR = ilosc+GetField(dw,"iloscdosp")		//iloscR>=0
		wartoscR = wartosc + GetField(dw,"wartoscdosp")
		if Sign(iloscR,4) || Sign(wartoscR) then
			if bTemp then bTemp=0 : TextOut("Zbieranie informacji o rekordach DW do ktrych brakuje rekordw przyj PW\n")
			idx = GetIndex(idtw)
			if !idx then
				if ilosc_tow then grow tToAdd,1 : grow tIdtw,1 : grow tStartIdx,1 : grow tLastIdx,1
				ilosc_tow += 1
				idx = ilosc_tow
				tStartIdx(idx)=size(tToAdd)
				tLastIdx(idx)=size(tToAdd)
				tIdTw(idx)=idtw
			else
				lTemp = tLastIdx(idx)
				grow tToAdd,1
				tToAdd(lTemp).pNext = size(tToAdd)
				tLastIdx(idx) = size(tToAdd)
			endif
			tToAdd(tLastIdx(idx)).ilosc = iloscR
			tToAdd(tLastIdx(idx)).wartosc = wartoscR
			tToAdd(tLastIdx(idx)).magazyn = GetField(dw,"magazyn")
			tToAdd(tLastIdx(idx)).id = GetField(dw,"id")
			tToAdd(tLastIdx(idx)).super = GetField(dw,"flag")
			TextOut(using"Brak rekordw przyj PW dla dostawy '%s' id=%l na ilo %.2f i warto %.2f\n",GetField(dw,"kod"),GetField(dw,"id"),iloscR,wartoscR)
		endif
	endif
	err = GetRec(dw,NX)
wend
	

// przypisywanie do kolejnych pozycji przychodowych
PopUp(1,"") : PopUp(2,"")
SetKey(pw,"dostawy")
SetKeySeg(mz,"id",0)
SetKey(xt,"id")
progress.reset(lSubSet)
for i=1 to i>lSubSet
	progress.NextOne()
	SetKeySeg(mz,"id",tSubSet(i))
	if !GetRec(mz,EQ) then
		SetKeySeg(xt,"id",GetField(mz,"magazyn"))
		if !GetRec(xt,EQ) && !(GetField(xt,"flag")&0x10) then
			ilosc = wartosc = 0
			CountPWforMZ(tSubSet(i),37,-1,"")
			iloscR = ilosc-GetField(mz,"ilosc")		//iloscR>=0
			wartoscR = wartosc - GetField(mz,"wartNetto")	//wartoscR>=0
			if Sign(iloscR,4) || Sign(wartoscR) then
				if Sign(iloscR,4) && Sign(wartoscR) then
					// brakuje -> pobieram rekordy DW -> na pewno wicej ni jeden
					if TextOutAndAsk(11,(using "Brak rekordw dostaw z bazy PW dla pozycji '%s' id=%l na ilo %.2f i warto %.2f",GetField(mz,"kod"),GetField(mz,"id"),iloscR,wartoscR),". Czy doda rekord do bazy PW?") then
						idtw = GetField(mz,"idtw")
						idx = GetIndex(idtw)
						if !idx then
							TextOut(" - brak dostaw do ktrych mona doczy wydania do tej pozycji"+sNoRepair)
						else
							// sprawdzam czy wystarczy dostaw
							iloscS=wartoscS=0
							lTemp = tStartIdx(idx)
							while lTemp
								if tToAdd(lTemp).magazyn==GetField(mz,"magazyn") then iloscS += tToAdd(lTemp).ilosc : wartoscS += tToAdd(lTemp).wartosc
							lTemp = tToAdd(lTemp).pNext
							wend
							if Sign(iloscR-iloscS,4)>0 || Sign(wartoscR-wartoscS)>0 then
								TextOut(" - brak wystarczajcej iloci dostaw aby uzupeni brak pozycji magazynowej"+sNoRepair)
							else
								lTemp = tStartIdx(idx)
								while lTemp && (Sign(iloscR,4)>0 || Sign(wartoscR)>0)
									if tToAdd(lTemp).magazyn==GetField(mz,"magazyn") then
										Clear(pw)
										SetField(pw,"typi",37)
										SetField(pw,"iddkmg",GetField(mz,"super"))
										SetField(pw,"idmg",GetField(mz,"id"))
										SetField(pw,"iddw",tToAdd(lTemp).id)
										SetField(pw,"idtw",idtw)
										SetField(pw,"flag",8+4*(tToAdd(lTemp).super&1))
										if Sign(wartoscR-tToAdd(lTemp).wartosc)>=0 then
											wartoscS = -tToAdd(lTemp).wartosc
										else
											wartoscS = -wartoscR
										endif
										SetField(pw,"wartosc",wartoscS)
										if Sign(iloscR-tToAdd(lTemp).ilosc,4)>=0 then
											iloscS = -tToAdd(lTemp).ilosc
										else
											iloscS = -iloscR
										endif
										SetField(pw,"ilosc",iloscS)
										if InsRec(pw) then
											TextOut(" - bd wstawiania nowego rekordu do bazy PW - NIE NAPRAWIONO\n")
										else
											TextOut(using " - dodano nowy rekord do bazy PW ilosc=%.2f wartosc=%.2f\n",-iloscS,-wartoscS)
											iloscR += iloscS
											wartoscR += wartoscS
											tToAdd(lTemp).ilosc += iloscS
											tToAdd(lTemp).wartosc += wartoscS
										endif
									endif
									lTemp = tToAdd(lTemp).pNext
								wend
							endif
							if Sign(iloscR,4) || Sign(wartoscR) then
								TextOut("   - POZYCJA NIE ZOSTAA W PENI NAPRAWIONA\n")
							else
								TextOut(sRepaired)
							endif
						endif
					else
						TextOut(sNoRepair)
					endif
				else
					TextOutAskOkEnd(12,(using "Wykryto niespjno rekordw pozycji magazynowej '%s' id=%l",GetField(mz,"kod"),GetField(mz,"id")))
				endif
			endif
		endif
	endif
next i

StageSummary(4)

endif // stage

int sub GetSpecRec(int b, long id, string basname)
	SetKeySeg(b,"id",id)
	GetSpecRec = GetRec(b,EQ)
	if GetSpecRec then
	 	if TextOutAndAsk(17, (using "Brak rekordu %s id=%l skojarzonego z rekordem PW id=%l.\n",basname,id,GetField(pw,"id")), "Czy usun rekord PW?") then
			DeleteRec(pw,"PW")
		else
			TextOut(sNoRepair)
		endif
	endif
endsub


// sprawdzenie czy PW czy dostaw i pozycj/rezerwacj tego samego towaru w tym samym magazynie
SetKey(pw,"id")
SetKey(mz,"id")
SetKey(dw,"id")
SetKey(zz,"id")
SetKey(dp,"id")
SetKey(bp,"id")
SetKey(bz,"id")
err=GetRec(pw,FS)
progress.Reset(GetRecordCount(pw))
PopUp(1,"Sprawdzanie spjnoci towarw i magazynw")
popup(2,"")

if !StageT(5) then err=1

while !err

// sprawdzanie dokladnosci wartosci
	DiagWart("ilosc",4)
	DiagWart("wartosc",2)
	DiagWart("ilosczreal",4)

	progress.NextOne()
	select case GetField(pw,"typi")
		case 37
			if (!GetField(pw,"iddkmg")) then
				ret = TextOutAndAsk(15,(using "Rekord PW id=%l nie jest skojarzony z dokumentem magazynowym poprzez pole iddkmg",GetField(pw,"id")),".\nCzy naprawi?")
				SetKeySeg(mz,"id",GetField(pw,"idmg"))
				IF ret && (!GetRec(mz,EQ)) THEN			
					SetField(pw, "iddkmg", GetField(mz,"super"))
					UpdateRec(pw, "PW")
				ELSE
					TextOut( sNoRepair )
				ENDIF
			endif
			if !GetSpecRec( dw, GetField(pw,"iddw"), "dostawy") && !GetSpecRec(mz, GetField(pw,"idmg"), "pozycji magazynowej") then
				if GetField(mz,"idtw")!=GetField(pw,"idtw") || GetField(pw,"idtw")!=GetField(dw,"idtw") then
					TextOutAskOkEnd(16,using "Rekord PW id=%l jest skojarzony z pozycj lub dostaw innego towaru",GetField(pw,"id"))
				endif
				if GetField(mz,"magazyn")!=GetField(dw,"magazyn") then
					TextOut(using "Rekord PW id=%l czy pozycj dokumentu magazynowego z dostaw w rnych magazynach.\n",GetField(pw,"id"))
				endif
			endif
		case 26	// rezerwacja
			if !GetSpecRec( dw, GetField(pw,"iddw"), "dostawy") && !GetSpecRec(zz, GetField(pw,"idmg"), "rezerwacji") then
				if GetField(dw,"idtw")!=GetField(pw,"idtw") || (GetField(pw,"idtw")!=GetField(zz,"id1") && GetField(zz,"baza1")==22) then
					TextOut(using "Rekord PW id=%l jest skojarzony z rezerwacj lub dostaw innego towaru.\n",GetField(pw,"id"))
				else
					// DW-PW-ZZ jest ok, sprawdzamy DW-PW-ZZ-DP/BP/MZ/BZ
					i=0
					Select case GetField(zz,"baza3")
						case 16
							i=dp
							buf = "pozycji handlowej"
						case 28
							i=bp
							buf = "pozycji handlowej w buforze"
						case 33
							i=mz
							buf = "pozycji magazynowej"
						case 38
							i=bz
							buf = "pozycji magazynowej w buforze"
					endselect
					if i && !GetSpecRec(i,GetField(zz,"id3pos"),buf) then
						if GetField(i,"idtw")!=GetField(dw,"idtw") then TextOut(using "Rekord PW id=%l czy dostaw oraz rekord %s dla rnych towarw.\n",GetField(pw,"id"),buf)
						if GetField(i,"magazyn")!=GetField(dw,"magazyn") then TextOut(using "Rekord PW id=%l czy dostaw oraz rekord %s w rnych magazynach.\n",GetField(pw,"id"),buf)
					endif
				endif
				if GetField(zz,"magazyn")!=GetField(dw,"magazyn") then
					TextOut(using "Rekord PW id=%l czy rezerwacj z dostaw w rnych magazynach.\n",GetField(pw,"id"))
				endif
			endif			
	endselect
	err=GetRec(pw,NX)
wend

PopUp(1,"Sprawdzanie spjnoci rezerwacji")
popup(2,"")
SetKey(zz, "cross1")
SetKeySeg(zz, "typi", 0x60)
err = GetRec(zz,GE)
while !err && GetField(zz, "typi") == 0x60
	nFlag = -1
	bRozne = 0
	bIlosciowa = 0
	SetKey(pw, "dostawy")
	SetKeySeg(pw,"typi", 26)
	SetKeySeg(pw, "idmg", GetField(zz, "id"))
	ret = GetRec(pw, GE)
	while !ret && GetField(pw, "typi") == 26 && GetField(pw, "idmg") == GetField(zz, "id")
		if(nFlag == -1) then
			nFlag = GetField(pw, "flag")
		else
			if nFlag != GetField(pw,"flag") then bRozne = 1
		endif
		if ((nFlag & 0x01)  ==  0x01) then bIlosciowa = 1		
		ret = GetRec(pw, NX)
	wend

	if bRozne then
		if bIlosciowa then		
			if TextOutAndAsk(18, (using "Rekord rezerwacji ZZ o id = '%l' jest powizany z rekordami PW okrelajcymi rne rodzaje rezerwacji", GetField(zz, "id")),". Czy naprawi (zostawi tylko rekord PW rezerwacji ilociowej)?") then
				SetKey(pw, "dostawy")
				SetKeySeg(pw,"typi", 26)
				SetKeySeg(pw, "idmg", GetField(zz, "id"))
				ret = GetRec(pw, GE)
				while !ret && GetField(pw, "typi") == 26 && GetField(pw, "idmg") == GetField(zz, "id")
					if((GetField(pw, "flag") & 0x01) != 0x01) then
						DeleteRec(pw,"PW")
					endif
					ret = GetRec(pw, NX)
				wend
			else
				TextOut(sNoRepair)
			endif
		else
			TextOut(using "Znaleziono niespjno dla rekordu rezerwacji ZZ o id = '%l'. Jest on powizany z rekordami PW okrelajcymi rzne rodzaje rezerwacji", GetField(zz, "id"))
		endif	
	endif
	err = GetRec(zz, NX)	
wend

StageSummary(5)

if bZostalo then TextOut("\n Uruchom raporty diagnostyczne dla baz DW oraz MZ a nastpnie ponownie ten raport.\n")
ShowFileInfo()

buf = IIF( GetVError() == 0 , "" , "errorDiagPW" )