//"diag_sm.sc","51sm : diagnostyka stanw magazynowych",12004,0,1.0.0,SYSTEM
//"Diagnostyka",12001,14,16
////////////////////////////
// 51sm : diagnostyka stanw magazynowych
// diag_sm.sc
////////////////////////////
// napisa: Sebastian Nowak
// data:    99.02.19

string NAZWA_PLIKU = "DIAG_SM.TXT"

string sRaportDescription

#include "Diagnostyka - funkcje"

#define XTttowKOMPLET   3

UsunRekord_0("SM")

sDialogTitle += "stanw magazynowych"

StageAddDesc("Raport sprawdza czy zgadzaj si wartoci stanw magazynowych towarw w")
StageAddDesc("poszczeglnych magazynach z odpowiednimi sumami dostaw i rezerwacji.")
StageAddDesc("Ponadto raport sprawdza obecno i poprawno rekordw sumujcych stany")
StageAddDesc("towarw po magazynach.")
StageAddStage("Sprawdzanie towarw")
StageAddStage("Sprawdzanie stanw magazynowych")
ChooseStages(400)


int tw,tw2,sm,sm2,iTemp,dw,zz,i,errM,mz,errD,xt
BasePW pw
BaseSM sm3
MapValue mIloscHandlowa
MapValue mRezIlosciowe
MapValue mRezWszystkie
MapValue mWartosc
long idtw
float old,stan,stanHandl,wartosc
Long   lValue

// ***********************

int sub ZnajdzTowar( string typ )
	ZnajdzTowar=0
	SetKeySeg(tw2,"kod",GetField(sm,"kod"))
	SetKeySeg(tw2,"typi",val(typ))
	if !GetRec(tw2,EQ) then
		// jest towar o takim kodzie -> czy moliwa zmiana tj. czy ju istnieje stan tego towaru
		SetKeySeg(sm2,"idtw",GetField(tw2,"id"))
		SetKeySeg(sm2,"magazyn",GetField(sm,"magazyn"))
		if !GetRec(sm2,EQ) then
			// ju istnieje
			if TextOutAndAsk(1,(using "Stan magazynowy id=%l towaru '%s' odwouje si do niewaciwego rekordu w bazie towarw. Znaleziono towar o takim samym kodzie, lecz posiada on ju rekord stanu magazynowego",GetField(sm,"id"),GetField(sm,"kod")),". Czy usun rekord stanu magazynowego?") then
				DeleteRec(sm,"SM")
				ZnajdzTowar=1
			else
				TextOut(sNoRepair)
			endif
		else
			// nie ma -> mona go podczy
			if TextOutAndAsk(2,(using "Stan magazynowy id=%l towaru '%s' odwouje si do niewaciwego rekordu w bazie towarw. Znaleziono towar o takim samym kodzie",GetField(sm,"id"),GetField(sm,"kod")),". Czy doczy go do stanu magazynowego?") then
				SetField(sm,"idtw",GetField(tw2,"id"))
				UpdateRec(sm,"SM")
				ZnajdzTowar=1
			else
				TextOut(sNoRepair)
			endif
		endif
	endif
endsub

int sub ZbierzZZDlaTypu(string typ)
	int err2
	SetKeySeg(zz,"typi",val(typ))
	SetKeySeg(zz,"baza1",22)
	SetKeySeg(zz,"id1",idtw)
	SetKeySeg(zz,"baza2",0)
	SetKeySeg(zz,"id2",0)
	err2=GetRec(zz,GE)
	while !err2 && GetField(zz,"typi")==val(typ) && GetField(zz,"baza1")==22 && GetField(zz,"id1")==idtw
		buf=using "%d",GetField(zz,"magazyn")
		old=mRezWszystkie.Get(buf,0)
		mRezWszystkie.Set(buf,old+GetField(zz,"ilosc"))
		if !(GetField(zz,"subtypi")&0x01) then
			old=mWartosc.Get(buf,0)
			mWartosc.Set(buf,old+GetField(zz,"cena"))
		endif
		err2=GetRec(zz,NX)
	wend
endsub

int sub CheckSign()
	SetKey(xt,"id")
	SetKeySeg(xt,"id",GetField(sm2,"magazyn"))
	if !GetRec(xt,EQ) && !(GetField(xt,"flag")&0x10) then 
	if Sign(GetField(sm,"stan"))<0 || Sign(GetField(sm,"stanHandl"))<0 || Sign(GetField(sm,"wartosc"))<0 then
		firma.Magazyn(GetField(sm,"magazyn"))
		TextOut(using "Stan towaru '%s' w magazynie '%s' lub warto towaru w tym magazynie jest ujemna.\n",GetField(sm,"kod"),firma.kodmagazynu)
	endif
	endif
endsub

int sub DiagWart(string pole, int prec)
float wart
float id
	wart = GetField(sm,pole)
	id = GetField(sm,"id")
	if !sign(wart,prec+3) then SetField(sm,pole,0):PutRec(sm)
	if sign(wart-round(wart,prec),6) then
		if TextOutAndAsk(53,(using "Warto pola '%s' posiada cyfry poza wymagan pozycj dokadnoci. Rekord id=%d",pole,id),(". Czy zaokrgli?")) then
			SetField(sm,pole,round(wart,prec))
			UpdateRec(sm,"SM")
		else
			TextOut(sNoRepair)
		endif
	endif
endsub
// ***********************


TextOut("Podsumowanie sprawdzania poprawnoci bazy stanw magazynowych\n\n")

tw=OpenBase("tw")
tw2=OpenBase("tw")
sm=OpenBase("sm")
sm2=OpenBase("sm")
sm3.Open()
pw.Open()

SetKey(tw,"id")
SetKey(sm,"id")
err=GetRec(sm,FS)

// czy dla wszystkich rekordw SM s rekordy w TW i czy s odpowiednie
pw.SetKey("pozycje")
SetKey(tw2,"kod")
SetKey(sm,"id")
SetKey(sm2,"towar")
sm3.SetKey("kod")

SetKey(tw,"id")
progress.Reset(GetRecordCount(sm))
PopUp(1,"Sprawdzanie towarw")
err=GetRec(sm,FS)

if !StageT(1) then err=1

while !err

// sprawdzanie dokladnosci wartosci
	DiagWart("stan",4)
	DiagWart("stanHandl",4)
	DiagWart("wartosc",2)

	PopUp(2,GetField(sm,"kod"))
	SetKeySeg(tw,"id",GetField(sm,"idtw"))
	if GetRec(tw,EQ) then
		// prba znalezienia na podstawie kodu towaru
		if GetField(sm,"magazyn")==0 then
			if !ZnajdzTowar("0") && !ZnajdzTowar("100") then
				// nie ma i nie ma o podobnym kodzie
				if TextOutAndAsk(3,(using "Stan magazynowy id=%l towaru '%s' odwouje si do niewaciwego rekordu w bazie towarw",GetField(sm,"id"),GetField(sm,"kod")),". Czy usun rekord stanu magazynowego?") then
					DeleteRec(sm,"SM")
				else
					TextOut(sNoRepair)
				endif
			endif
		else
			if !ZnajdzTowar("0") then
				// nie ma i nie ma o podobnym kodzie
				Firma.Magazyn(GetField(sm,"magazyn"))
				if TextOutAndAsk(4,(using "Stan magazynowy id=%l towaru '%s' w magazynie '%s' odwouje si do niewaciwego rekordu w bazie towarw",GetField(sm,"id"),GetField(sm,"kod"),firma.kod),". Czy usun rekord stanu magazynowego?") then
					DeleteRec(sm,"SM")
				else
					TextOut(sNoRepair)
				endif
			endif
		endif
	else
		if GetField(tw,"kod")!=GetField(sm,"kod") then
			sm3.SetKeySeg("magazyn",GetField(sm,"magazyn"))
			sm3.SetKeySeg("kod",GetField(tw,"kod"))
			err=!sm3.GetRec(EQ)
			buf="(U&su:o)(P&omi:p)[&Przepisz kod towaru:t](&Przerwij:a)"
			if err then buf = "[U&su:o](P&omi:p)(&Przerwij:a)"
			err=TextOutAndAsk2(19+err,(using "Rekord stanu magazynowego id=%l poprzez kod towaru oraz id czy dwa rne towary",GetField(sm,"id")),(using "\nKod z rekordu SM: '%s'\nKod z rekordu TW: '%s'\nCzy usun rekord?",GetField(sm,"kod"),GetField(tw,"kod")),buf)
			if err==6 then
				SetField(sm,"kod",GetField(tw,"kod"))
				SetField(sm,"nazwa",GetField(tw,"nazwa"))
				SetField(sm,"kodpaskowy",GetField(tw,"kodpaskowy"))
				UpdateRec(sm,"SM")
				err=1
			else
				if err then
					DeleteRec(sm,"SM")
					err=0
				else
					TextOut(sNoRepair)
					err=1
				endif
			endif
		endif
		if err then
			if GetField(tw,"typi")==100 && !Sign(GetField(sm,"stan")) then
				err=5
				if GetField(sm,"magazyn") then
					err+=1
					Firma.Magazyn(GetField(sm,"magazyn"))
					buf = using "Towar '%s' znajdujcy si w koszu posiada stan zerowy w magazynie '%s' oraz rekord stanu magazynowego w bazie SM",GetField(tw,"kod"),firma.kodmagazynu
				else
					buf = using "Towar '%s' znajdujcy si w koszu ktrego stan we magazynach wynosi zero posiada rekord stanu magazynowego",GetField(tw,"kod")
				endif
				if TextOutAndAsk(err,buf,". Czy usun ten rekord?") then
					DeleteRec(sm,"SM")
				else
					TextOut(sNoRepair)
				endif
			else
				if GetField(sm,"subtypi")!=GetField(tw,"subtypi") then
					if TextOutAndAsk(16,(using "Stan magazynowy id=%l jest innego (sub)typu ni towar '%s'",GetFIeld(sm,"id"),GetField(tw,"kod")),sAskRepair) then
						SetField(sm,"subtypi",GetFIeld(tw,"subtypi"))
						UpdateRec(sm,"SM")
					else
						TextOut(sNoRepair)
					endif
				endif
			endif
		endif
		if (GetField(tw,"subtypi")==XTttowKOMPLET &&  Sign(GetField(sm,"stan"))) then
			SetField(sm,"stan",0)
			UpdateRec(sm,"SM")
		endif
	endif
	
	err=GetRec(sm,NX)
wend

StageSummary(1)

// zlicz stany towarw dla magazynw
PopUp(1,"Zliczanie stanw magazynowych")
dw=OpenBase("dw")
zz=OpenBase("zz")
mz=OpenBase("mz")
xt=OpenBase("xt")
SetKey(zz,"cross1")
SetKey(dw,"towar")
SetKey(sm,"towar")
SetKey(tw,"id")
SetKey(mz,"tw")
SetKey(xt,"id")

mIloscHandlowa.Type(float)
mRezIlosciowe.Type(float)
mRezWszystkie.Type(float)
mWartosc.Type(float)
// po kolejnych towarach
errM=GetRec(dw,FS)
while !errM && (GetField(dw,"idtw")<0 || (!GetField(dw,"idtw") && GetField(dw,"subtypi") == 2))
	errM=GetRec(dw,NX)
wend
if !errM then idtw=GetField(dw,"idtw")

if !StageT(2) then errM=1

while !errM
	mIloscHandlowa.Clear()
	mRezIlosciowe.Clear()
	mRezWszystkie.Clear()
	mWartosc.Clear()
	do
		// kolejne rekordy dostaw dla tego samego towaru
		PopUp(2,GetField(dw,"kod"))
		if GetField(dw,"magazyn") then
			buf=using "%d",GetField(dw,"magazyn")
			if GetField(dw,"numer")<0 then
			if Sign(GetField(dw,"iloscdosp"),4) then
				old=mRezIlosciowe.Get(buf,0)
				mRezIlosciowe.Set(buf,old+GetField(dw,"iloscdosp"))
				mIloscHandlowa.Set(buf,mIloscHandlowa.Get(buf,0))
				mWartosc.Set(buf,mWartosc.Get(buf,0))
			endif
			else
				old=mIloscHandlowa.Get(buf,0)
				mIloscHandlowa.Set(buf,old+GetField(dw,"iloscdosp"))
				old = mWartosc.Get(buf,0)
				mWartosc.Set(buf,old+GetField(dw,"wartoscdosp"))
				mRezIlosciowe.Set(buf,mRezIlosciowe.Get(buf,0))
			endif
			mRezWszystkie.Set(buf,mRezWszystkie.Get(buf,0))
		else
			// zerowy magazyn - nie powinno go by
			pw.SetKeySeg("typi",37)
			pw.SetKeySeg("iddw",GetField(dw,"id"))
			pw.SetKeySeg("idmg",0)
			buf=""
			if !pw.GetKey(GE) && pw.GetKeySeg("typi")==37 && pw.GetKeySeg("iddw")==GetField(dw,"id") then buf="pozycji magazynowych"
			if !buf then
				pw.SetKeySeg("typi",26)
				pw.SetKeySeg("iddw",GetField(dw,"id"))
				pw.SetKeySeg("idmg",0)
				if !pw.GetKey(GE) && pw.GetKeySeg("typi")==26 && pw.GetKeySeg("iddw")==GetField(dw,"id") then buf="rezerwacji"
			endif
			if buf then
				TextOutAskOkEnd(17,(using"Rekord dostawy '%s' id=%l przypisany jest do nieistniejcego magazynu id=0 oraz istniej dowizane do niego rekordy %s\n",GetField(dw,"kod"),GetField(dw,"id"),buf))
			else
				if TextOutAndAsk(18,(using"Rekord dostawy '%s' id=%l przypisany jest do nieistniejcego magazynu id=0",GetField(dw,"kod"),GetField(dw,"id")),"\nCzy usun rekord tej dostawy?") then
					DeleteRec(dw,"DW")
				else
					TextOut(sNoRepair)
				endif
			endif
		endif
		errM=GetRec(dw,NX)
		while !errM && (GetField(dw,"idtw")<0 || (!GetField(dw,"idtw") && GetField(dw,"subtypi") == 2))
			errM=GetRec(dw,NX)
		wend
	loop while !errM && GetField(dw,"idtw")==idtw
	// zebranie rekordw ZZ do tego towaru
	ZbierzZZDlaTypu("98")
	ZbierzZZDlaTypu("96")

	SetKeySeg(mz,"idtw",idtw)
	errD=GetRec(mz,EQ)
	while !errD && GetField(mz,"idtw")==idtw
		if !(GetField(mz,"typi")&0x01) && GetField(mz,"magazyn") then
			SetKeySeg(xt,"id",GetField(mz,"magazyn"))
			if !GetRec(xt,EQ) && (GetField(xt,"flag")&0x10) then
				buf=using "%d",GetField(mz,"magazyn")
				old=mIloscHandlowa.Get(buf,0)
				mIloscHandlowa.Set(buf,old-GetField(mz,"ilosc"))
				old=mWartosc.Get(buf,0)
				mWartosc.Set(buf,old-GetField(mz,"wartTowaru"))
				mRezIlosciowe.Set(buf,mRezIlosciowe.Get(buf,0))
				mRezWszystkie.Set(buf,mRezWszystkie.Get(buf,0))
			endif
		endif
		errD=GetRec(mz,NX)
	wend


	// sprawdzenie czy w SM s takie wartoci
	SetKeySeg(tw,"id",idtw)
	if GetRec(tw,EQ) then TextOutAskOkEnd(7,using "Brak towaru id=%l dla ktrego istniej dostawy. Uruchom raport diagnostyczny dla bazy PW oraz DW",idtw)
	for i=1 to i>mIloscHandlowa.Size()
		SetKeySeg(sm,"idtw",idtw)
		SetKeySeg(sm,"magazyn",Val(mIloscHandlowa.GetKey(i)))
		if GetRec(sm,EQ) then
			buf=mIloscHandlowa.GetKey(i)
			stan = mIloscHandlowa.Get(buf)+mRezIlosciowe.Get(buf)+mRezWszystkie.Get(buf)
			if Sign(stan) || GetField(tw,"typi")!=100 then
				firma.Magazyn(Val(mIloscHandlowa.GetKey(i)))
				if TextOutAndAsk(8,(using"Brak rekordu stanu magazynowego towaru '%s' w magazynie '%s'",GetField(tw,"kod"),firma.kodmagazynu),sAskRepair) then
					Clear(sm)
					buf=mIloscHandlowa.GetKey(i)
					SetField(sm,"kod",GetField(tw,"kod"))
					SetField(sm,"nazwa",GetField(tw,"nazwa"))
					SetField(sm,"kodpaskowy",GetField(tw,"kodpaskowy"))
					SetField(sm,"stan",stan)
					SetField(sm,"stanHandl",mIloscHandlowa.Get(buf)+mRezIlosciowe.Get(buf))
					SetField(sm,"idtw",idtw)
					SetField(sm,"magazyn",Val(buf))
					SetField(sm,"wartosc",mWartosc.Get(buf))
					SetField(sm,"subtypi",GetField(tw,"subtypi"))
					if !InsertRec(sm,"SM") then CheckSign()
				else
					TextOut(sNoRepair)
				endif
			endif
		else
			// czy wartoci si zgadzaj
			if GetField(tw,"subtypi")==0 then
				buf=mIloscHandlowa.GetKey(i)
				if Sign(GetField(sm,"stan")-mIloscHandlowa.Get(buf)-mRezIlosciowe.Get(buf)-mRezWszystkie.Get(buf)) || Sign(GetField(sm,"stanHandl")-mIloscHandlowa.Get(buf)-mRezIlosciowe.Get(buf)) || Sign( GetField(sm,"wartosc")-mWartosc.Get(buf),3) then
					firma.Magazyn(Val(buf))
					if TextOutAndAsk(9,(using "Nie zgadza si stan magazynowy towaru '%s' w magazynie '%s'",GetField(tw,"kod"),firma.kodmagazynu),(using ".\nstan: %.2f  powinno by:%.2f\nstan handlowy: %.2f powinno by:%.2f\nwarto: %.2f powinno by:%.2f\nCzy zapisa nowe wartoci?",GetField(sm,"stan"),mIloscHandlowa.Get(buf)+mRezIlosciowe.Get(buf)+mRezWszystkie.Get(buf),GetField(sm,"stanHandl"),mIloscHandlowa.Get(buf)+mRezIlosciowe.Get(buf),GetField(sm,"wartosc"),mWartosc.Get(buf))) then
						buf=mIloscHandlowa.GetKey(i)
						SetField(sm,"stan",mIloscHandlowa.Get(buf)+mRezIlosciowe.Get(buf)+mRezWszystkie.Get(buf))
						SetField(sm,"stanHandl",mIloscHandlowa.Get(buf)+mRezIlosciowe.Get(buf))
						SetField(sm,"wartosc",mWartosc.Get(buf))
						UpdateRec(sm,"SM")
					else
						TextOut(sNoRepair)
					endif
				endif
			else
				// usuga lub zestaw do ktrego jest rezerwacja (istnieje rekord DW 'rezerwacja ilociowa')
				if Sign(GetField(sm,"stan")) || Sign(GetField(sm,"stanHandl")-1) || Sign(GetField(sm,"wartosc")) then
					firma.Magazyn(Val(mIloscHandlowa.GetKey(i)))
					if TextOutAndAsk(10,(using "Nie zgadza si stan magazynowy usugi/zestawu '%s' w magazynie '%s'",GetField(tw,"kod"),firma.kodmagazynu),(using ".\nstan: %.2f  powinno by: 0\nstan handlowy: %.2f powinno by: 1\nwarto: %.2f powinno by: 0\nCzy zapisa nowe wartoci?",GetField(sm,"stan"),GetField(sm,"stanHandl"),GetField(sm,"wartosc"))) then
						SetField(sm,"stan",0)
						SetField(sm,"stanHandl",1)
						SetField(sm,"wartosc",0)
						UpdateRec(sm,"SM")
					else
						TextOut(sNoRepair)
					endif
				endif
			endif
			CheckSign()
		endif
	next i

	// sprawdzenie czy w SM jest wicej rekordw ni te sprawdzone

	SetKeySeg(sm,"idtw",idtw)
	SetKeySeg(sm,"magazyn",0)
	err=GetRec(sm,GE)

	while !err && GetField(sm,"idtw")==idtw
		if GetField(sm,"magazyn")!=0 && GetField(sm,"subtypi")==0 && !mIloscHandlowa.Index(using "%d",GetField(sm,"magazyn")) then
			firma.Magazyn(GetField(sm,"magazyn"))
			// zapamietujemy liczbe bledow weryfikacji przed migracja (ponizsze pytanie ja zwieksza)
			If EnabledVMarker() Then lValue = VError
			if TextOutAndAsk(11,(using "Znaleziono rekord id=%l stanu magazynu towaru '%s' nie posiadajcego dostaw do magazynu '%s' (ilosc=%.2f)",GetField(sm,"id"),GetField(tw,"kod"),firma.kodmagazynu,GetField(sm,"stan")),". Czy usun rekord stanu magazynowego?") then
				DeleteRec(sm,"SM")
			else
				If EnabledVMarker() Then
					// weryfikacja przed migracja - naprawiamy
					DeleteRec(sm,"SM")
				Else
					TextOut(sNoRepair)
				EndIf
			endif
			// odtwarzamy liczbe bledow weryfikacji przed migracja
			If EnabledVMarker() Then VError = lValue
		endif
		err=GetRec(sm,NX)
	wend

	// sprawdzenie stanu rekordw sumujcych po magazynach
	stan = stanHandl = wartosc = 0
	for i=1 to i>mIloscHandlowa.Size()
		buf = mIloscHandlowa.GetKey(i)
		stan += mIloscHandlowa.Get(buf)+mRezIlosciowe.Get(buf)+mRezWszystkie.Get(buf)
		stanHandl += mIloscHandlowa.Get(buf)+mRezIlosciowe.Get(buf)
		wartosc += mWartosc.Get(buf)
	next i
	SetKeySeg(sm,"idtw",idtw)
	SetKeySeg(sm,"magazyn",0)
	if GetRec(sm,EQ) then
		if GetField(tw,"typi")!=100 then
			if TextOutAndAsk(12,(using "Brak rekordu sumujcego stany towaru '%s' po magazynach",GetField(tw,"kod")),sAskRepair) then
				Clear(sm)
				SetField(sm,"subtypi",GetField(tw,"subtypi"))
				SetField(sm,"kod",GetField(tw,"kod"))
				SetField(sm,"nazwa",GetField(tw,"nazwa"))
				SetField(sm,"kodpaskowy",GetField(tw,"kodpaskowy"))
				SetField(sm,"idtw",GetField(tw,"id"))
				SetField(sm,"stan",stan)
				SetField(sm,"stanHandl",stanHandl)
				SetField(sm,"wartosc",wartosc)
				InsertRec(sm,"SM")
			else
				TextOut(sNoRepair)
			endif
		endif
	else
		// porwnujemy wartosci

		if GetField(tw,"subtypi")==0 then
			if Sign(GetField(sm,"stan")-stan) || Sign(GetField(sm,"stanHandl")-stanHandl) || Sign(GetField(sm,"wartosc")-wartosc,3) then
				if TextOutAndAsk(13,(using"Nie zgadzaj si stany magazynowe lub wartoci rekordu sumujcego stany magazynowe towaru '%s' po magazynach",GetField(tw,"kod")),(using "\nstan: %.2f powinno by: %.2f\nstan handlowy: %.2f powinno by: %.2f\nwarto: %.2f powinno by: %.2f\nCzy zapisa nowe wartoci?",GetField(sm,"stan"),stan,GetField(sm,"stanHandl"),stanHandl,GetField(sm,"wartosc"),wartosc)) then
					SetField(sm,"stan",stan)
					SetField(sm,"stanHandl",stanHandl)
					SetField(sm,"wartosc",wartosc)
					UpdateRec(sm,"SM")
				else
					TextOut(sNoRepair)
				endif
			endif
		else
			// usuga lub zestaw
			if Sign(GetField(sm,"stan")) || Sign(GetField(sm,"stanHandl")-1) || Sign(GetField(sm,"wartosc")) then
				if TextOutAndAsk(14,(using "Nie zgadzaj si wartoci w rekordzie sumujcym stany magazynowe usugi/zestawu '%s'",GetField(tw,"kod")),(using ".\nstan: %.2f  powinno by: 0\nstan handlowy: %.2f powinno by: 1\nwarto: %.2f powinno by: 0\nCzy zapisa nowe wartoci?",GetField(sm,"stan"),GetField(sm,"stanHandl"),GetField(sm,"wartosc"))) then
					SetField(sm,"stan",0)
					SetField(sm,"stanHandl",1)
					SetField(sm,"wartosc",0)
					UpdateRec(sm,"SM")
				else
					TextOut(sNoRepair)
				endif
			endif
		endif		
	endif

	idtw=GetField(dw,"idtw")
wend

StageSummary(2)

ShowFileInfo()

buf = IIF( GetVError() == 0 , "" , "errorDiagSM" )